Crazy Eddies GUI System: CEGUI::Window Class Reference

Crazy Eddies GUI System 0.7.6

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends
CEGUI::Window Class Reference

An abstract base class providing common functionality and specifying the required interface for derived classes. More...

Inherits CEGUI::PropertySet, and CEGUI::EventSet.

Inherited by CEGUI::ButtonBase, CEGUI::ClippedContainer, CEGUI::Combobox, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::GroupBox, CEGUI::GUISheet, CEGUI::ItemEntry, CEGUI::ItemListBase, CEGUI::LayoutContainer, CEGUI::Listbox, CEGUI::ListHeader, CEGUI::ListHeaderSegment, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ProgressBar, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::ScrolledContainer, CEGUI::Slider, CEGUI::Spinner, CEGUI::TabControl, CEGUI::Titlebar, CEGUI::Tooltip, and CEGUI::Tree.

Collaboration diagram for CEGUI::Window:
[legend]

List of all members.

## Public Member Functions
| Window (const String &type, const String &name)
| Constructor for Window base class.
virtual | ~Window (void)
| Destructor for Window base class.
const String & | getType (void) const
| return a String object holding the type name for this Window.
const String & | getName (void) const
| return a String object holding the name of this Window.
bool | isDestroyedByParent (void) const
| returns whether or not this Window is set to be destroyed when its parent window is destroyed.
bool | isAlwaysOnTop (void) const
| returns whether or not this Window is an always on top Window. Also known as a top-most window.
bool | isDisabled (bool localOnly=false) const
| return whether the Window is currently disabled
bool | isVisible (bool localOnly=false) const
| return true if the Window is currently visible.
bool | isActive (void) const
| return true if this is the active Window. An active window is a window that may receive user inputs.
bool | isClippedByParent (void) const
| return true if this Window is clipped so that its rendering will not pass outside of its parent Window area.
uint | getID (void) const
| return the ID code currently assigned to this Window by client code.
size_t | getChildCount (void) const
| return the number of child Window objects currently attached to this Window.
bool | isChild (const String &name) const
| returns whether a Window with the specified name is currently attached to this Window as a child.
bool | isChild (uint ID) const
| returns whether at least one window with the given ID code is attached to this Window as a child.
bool | isChildRecursive (uint ID) const
| returns whether at least one window with the given ID code is attached to this Window or any of it's children as a child.
bool | isChild (const Window *window) const
| return true if the given Window is a child of this window.
Window * | getChild (const String &name) const
| return a pointer to the child window with the specified name.
Window * | getChild (uint ID) const
| return a pointer to the first attached child window with the specified ID value.
Window * | getChildRecursive (const String &name) const
| return a pointer to the first attached child window with the specified name. Children are traversed recursively.
Window * | getChildRecursive (uint ID) const
| return a pointer to the first attached child window with the specified ID value. Children are traversed recursively.
Window * | getChildAtIdx (size_t idx) const
| return a pointer to the child window that is attached to 'this' at the given index.
Window * | getActiveChild (void)
| return a pointer to the Window that currently has input focus starting with this Window.
const Window * | getActiveChild (void) const
bool | isAncestor (const String &name) const
| return true if the specified Window is some ancestor of this Window
bool | isAncestor (uint ID) const
| return true if any Window with the given ID is some ancestor of this Window.
bool | isAncestor (const Window *window) const
| return true if the specified Window is some ancestor of this Window.
Font * | getFont (bool useDefault=true) const
| return the active Font object for the Window.
const String & | getText (void) const
| return the current text for the Window
const String & | getTextVisual () const
| return text string with visual ordering of glyphs.
bool | inheritsAlpha (void) const
| return true if the Window inherits alpha from its parent(s).
float | getAlpha (void) const
| return the current alpha value set for this Window
float | getEffectiveAlpha (void) const
| return the effective alpha value that will be used when rendering this window, taking into account inheritance of parent window(s) alpha.
Rect | getUnclippedOuterRect () const
| Return a Rect that describes the unclipped outer rect area of the Window in screen pixels.
Rect | getUnclippedInnerRect () const
| Return a Rect that describes the unclipped inner rect area of the Window in screen pixels.
Rect | getUnclippedRect (const bool inner) const
| Return a Rect that describes the unclipped area covered by the Window.
Rect | getOuterRectClipper () const
| Return a Rect that describes the rendering clipping rect based upon the outer rect area of the window.
Rect | getInnerRectClipper () const
| Return a Rect that describes the rendering clipping rect based upon the inner rect area of the window.
Rect | getClipRect (const bool non_client=false) const
| Return a Rect that describes the rendering clipping rect for the Window.
Rect | getHitTestRect () const
| Return the Rect that descibes the clipped screen area that is used for determining whether this window has been hit by a certain point.
Rect | getChildWindowContentArea (const bool non_client=false) const
| Return a Rect that describes the area that is used to position and - for scale values - size child content attached to this Window.
virtual Rect | getUnclippedInnerRect_impl (void) const
| Return a Rect object that describes, unclipped, the inner rectangle for this window. The inner rectangle is typically an area that excludes some frame or other rendering that should not be touched by subsequent rendering.
bool | isCapturedByThis (void) const
| return true if this Window has input captured.
bool | isCapturedByAncestor (void) const
| return true if an ancestor window has captured inputs.
bool | isCapturedByChild (void) const
| return true if a child window has captured inputs.
virtual bool | isHit (const Vector2 &position, const bool allow_disabled=false) const
| check if the given pixel position would hit this window.
Window * | getChildAtPosition (const Vector2 &position) const
| return the child Window that is hit by the given pixel position
Window * | getTargetChildAtPosition (const Vector2 &position, const bool allow_disabled=false) const
| return the child Window that is 'hit' by the given position, and is allowed to handle mouse events.
Window * | getParent (void) const
| return the parent of this Window.
const Image * | getMouseCursor (bool useDefault=true) const
| Return a pointer to the mouse cursor image to use when the mouse cursor is within this window's area.
Size | getPixelSize (void) const
| Return the window size in pixels.
void * | getUserData (void) const
| Return the user data set for this Window.
bool | restoresOldCapture (void) const
| Return whether this window is set to restore old input capture when it loses input capture.
bool | isZOrderingEnabled (void) const
| Return whether z-order changes are enabled or disabled for this Window.
bool | wantsMultiClickEvents (void) const
| Return whether this window will receive multi-click events or multiple 'down' events instead.
bool | isMouseAutoRepeatEnabled (void) const
| Return whether mouse button down event autorepeat is enabled for this window.
float | getAutoRepeatDelay (void) const
| Return the current auto-repeat delay setting for this window.
float | getAutoRepeatRate (void) const
| Return the current auto-repeat rate setting for this window.
bool | distributesCapturedInputs (void) const
| Return whether the window wants inputs passed to its attached child windows when the window has inputs captured.
bool | isUsingDefaultTooltip (void) const
| Return whether this Window is using the system default Tooltip for its Tooltip window.
Tooltip * | getTooltip (void) const
| Return a pointer to the Tooltip object used by this Window. The value returned may point to the system default Tooltip, a custom Window specific Tooltip, or be NULL.
String | getTooltipType (void) const
| Return the custom tooltip type.
const String & | getTooltipText (void) const
| Return the current tooltip text set for this Window.
bool | inheritsTooltipText (void) const
| Return whether this window inherits Tooltip text from its parent when its own tooltip text is not set.
bool | isRiseOnClickEnabled (void) const
| Return whether this window will rise to the top of the z-order when clicked with the left mouse button.
bool | testClassName (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance hierarchy.
VerticalAlignment | getVerticalAlignment () const
| Get the vertical alignment.
HorizontalAlignment | getHorizontalAlignment () const
| Get the horizontal alignment.
GeometryBuffer & | getGeometryBuffer ()
| Return the GeometryBuffer object for this Window.
const String & | getLookNFeel () const
| Get the name of the LookNFeel assigned to this window.
bool | getModalState (void) const
| Get whether or not this Window is the modal target.
const String & | getUserString (const String &name) const
| Returns a named user string.
bool | isUserStringDefined (const String &name) const
| Return whether a user string with the specified name exists.
Window * | getActiveSibling ()
| Returns the active sibling window.
Size | getParentPixelSize (void) const
| Return the pixel size of the parent element. This always returns a valid object.
float | getParentPixelWidth (void) const
| Return the pixel Width of the parent element. This always returns a valid number.
float | getParentPixelHeight (void) const
| Return the pixel Height of the parent element. This always returns a valid number.
bool | isMousePassThroughEnabled (void) const
| Returns whether this window should ignore mouse event and pass them through to and other windows behind it. In effect making the window transparent to the mouse.
bool | isAutoWindow (void) const
| Returns whether this window is an auto-child window. All auto-child windows have "__auto_" in their name, but this is faster.
bool | isWritingXMLAllowed (void) const
| Returns whether this window is allowed to write XML.
EventSet::Iterator | getEventIterator () const
| Helper method that returns an EventSet::Iterator object that can be used to iterate over the events currently added to the EventSet of this Window.
PropertySet::Iterator | getPropertyIterator () const
| Helper method that returns a PropertySet::Iterator object that can be used to iterate over the events currently added to the PropertySet of this Window.
bool | isDragDropTarget () const
| Returns whether this Window object will receive events generated by the drag and drop support in the system.
void | getRenderingContext (RenderingContext &ctx) const
| Fill in the RenderingContext ctx with details of the RenderingSurface where this Window object should normally do it's rendering.
virtual void | getRenderingContext_impl (RenderingContext &ctx) const
| implementation of the default getRenderingContext logic.
RenderingSurface * | getRenderingSurface () const
| return the RenderingSurface currently set for this window. May return 0.
RenderingSurface & | getTargetRenderingSurface () const
| return the RenderingSurface that will be used by this window as the target for rendering.
bool | isUsingAutoRenderingSurface () const
| Returns whether automatic use of an imagery caching RenderingSurface (i.e. a RenderingWindow) is enabled for this window. The reason we emphasise 'automatic' is because the client may manually set a RenderingSurface that does exactly the same job.
const Window * | getRootWindow () const
| Returns the window at the root of the hierarchy starting at this Window. The root window is defined as the first window back up the hierarchy that has no parent window.
Window * | getRootWindow ()
const Vector3 & | getRotation () const
| return the rotations set for this window.
bool | isNonClientWindow () const
| Return whether the Window is a non-client window.
void | rename (const String &new_name)
| Renames the window.
virtual void | initialiseComponents (void)
| Initialises the Window based object ready for use.
void | setDestroyedByParent (bool setting)
| Set whether or not this Window will automatically be destroyed when its parent Window is destroyed.
void | setAlwaysOnTop (bool setting)
| Set whether this window is always on top, or not.
void | setEnabled (bool setting)
| Set whether this window is enabled or disabled. A disabled window normally can not be interacted with, and may have different rendering.
void | enable (void)
| enable the Window to allow interaction.
void | disable (void)
| disable the Window to prevent interaction.
void | setVisible (bool setting)
| Set whether the Window is visible or hidden.
void | show (void)
| show the Window.
void | hide (void)
| hide the Window.
void | activate (void)
| Activate the Window giving it input focus and bringing it to the top of all windows with the same always-on-top settig as this Window.
void | deactivate (void)
| Deactivate the window. No further inputs will be received by the window until it is re-activated either programmatically or by the user interacting with the gui.
void | setClippedByParent (bool setting)
| Set whether this Window will be clipped by its parent window(s).
void | setID (uint ID)
| Set the current ID for the Window.
void | setText (const String &text)
| Set the current text string for the Window.
void | insertText (const String &text, const String::size_type position)
| Insert the text string text into the current text string for the Window object at the position specified by position.
void | appendText (const String &text)
| Append the string text to the currect text string for the Window object.
void | setFont (Font *font)
| Set the font used by this Window.
void | setFont (const String &name)
| Set the font used by this Window.
void | addChildWindow (const String &name)
| Add the named Window as a child of this Window. If the Window name is already attached to a Window, it is detached before being added to this Window.
void | addChildWindow (Window *window)
| Add the specified Window as a child of this Window. If the Window window is already attached to a Window, it is detached before being added to this Window.
void | removeChildWindow (const String &name)
| Remove the named Window from this windows child list.
void | removeChildWindow (Window *window)
| Remove the specified Window form this windows child list.
void | removeChildWindow (uint ID)
| Remove the first child Window with the specified ID. If there is more than one attached Window objects with the specified ID, only the fist one encountered will be removed.
void | moveToFront ()
| Move the Window to the top of the z order.
void | moveToBack ()
| Move the Window to the bottom of the Z order.
void | moveInFront (const Window *const window)
| Move this window immediately above it's sibling window in the z order.
void | moveBehind (const Window *const window)
| Move this window immediately behind it's sibling window in the z order.
bool | captureInput (void)
| Captures input to this window.
void | releaseInput (void)
| Releases input capture from this Window. If this Window does not have inputs captured, nothing happens.
void | setRestoreCapture (bool setting)
| Set whether this window will remember and restore the previous window that had inputs captured.
void | setAlpha (float alpha)
| Set the current alpha value for this window.
void | setInheritsAlpha (bool setting)
| Sets whether this Window will inherit alpha from its parent windows.
void | invalidate (void)
| Invalidate this window causing at least this window to be redrawn during the next rendering pass.
void | invalidate (const bool recursive)
| Invalidate this window and - dependant upon recursive - all child content, causing affected windows to be redrawn during the next rendering pass.
void | setMouseCursor (const Image *image)
| Set the mouse cursor image to be used when the mouse enters this window.
void | setMouseCursor (MouseCursorImage image)
| Set the mouse cursor image to be used when the mouse enters this window.
void | setMouseCursor (const String &imageset, const String &image_name)
| Set the mouse cursor image to be used when the mouse enters this window.
void | setUserData (void *user_data)
| Set the user data set for this Window.
void | setZOrderingEnabled (bool setting)
| Set whether z-order changes are enabled or disabled for this Window.
void | setWantsMultiClickEvents (bool setting)
| Set whether this window will receive multi-click events or multiple 'down' events instead.
void | setMouseAutoRepeatEnabled (bool setting)
| Set whether mouse button down event autorepeat is enabled for this window.
void | setAutoRepeatDelay (float delay)
| Set the current auto-repeat delay setting for this window.
void | setAutoRepeatRate (float rate)
| Set the current auto-repeat rate setting for this window.
void | setDistributesCapturedInputs (bool setting)
| Set whether the window wants inputs passed to its attached child windows when the window has inputs captured.
void | notifyDragDropItemEnters (DragContainer *item)
| Internal support method for drag & drop. You do not normally call this directly from client code. See the DragContainer class.
void | notifyDragDropItemLeaves (DragContainer *item)
| Internal support method for drag & drop. You do not normally call this directly from client code. See the DragContainer class.
void | notifyDragDropItemDropped (DragContainer *item)
| Internal support method for drag & drop. You do not normally call this directly from client code. See the DragContainer class.
virtual void | destroy (void)
| Internal destroy method which actually just adds the window and any parent destructed child windows to the dead pool.
void | setTooltip (Tooltip *tooltip)
| Set the custom Tooltip object for this Window. This value may be 0 to indicate that the Window should use the system default Tooltip object.
void | setTooltipType (const String &tooltipType)
| Set the custom Tooltip to be used by this Window by specifying a Window type.
void | setTooltipText (const String &tip)
| Set the tooltip text for this window.
void | setInheritsTooltipText (bool setting)
| Set whether this window inherits Tooltip text from its parent when its own tooltip text is not set.
void | setRiseOnClickEnabled (bool setting)
| Set whether this window will rise to the top of the z-order when clicked with the left mouse button.
void | setVerticalAlignment (const VerticalAlignment alignment)
| Set the vertical alignment.
void | setHorizontalAlignment (const HorizontalAlignment alignment)
| Set the horizontal alignment.
virtual void | setLookNFeel (const String &look)
| Set the LookNFeel that shoule be used for this window.
void | setModalState (bool state)
| Set the modal state for this Window.
virtual void | performChildWindowLayout ()
| method called to perform extended laying out of attached child windows.
void | setUserString (const String &name, const String &value)
| Sets the value a named user string, creating it as required.
void | setArea (const UDim &xpos, const UDim &ypos, const UDim &width, const UDim &height)
| Set the window area.
void | setArea (const UVector2 &pos, const UVector2 &size)
| Set the window area.
void | setArea (const URect &area)
| Set the window area.
void | setPosition (const UVector2 &pos)
| Set the window's position.
void | setXPosition (const UDim &x)
| Set the window's X position.
void | setYPosition (const UDim &y)
| Set the window's Y position.
void | setSize (const UVector2 &size)
| Set the window's size.
void | setWidth (const UDim &width)
| Set the window's width.
void | setHeight (const UDim &height)
| Set the window's height.
void | setMaxSize (const UVector2 &size)
| Set the window's maximum size.
void | setMinSize (const UVector2 &size)
| Set the window's minimum size.
const URect & | getArea () const
| Return the windows area.
const UVector2 & | getPosition () const
| Get the window's position.
const UDim & | getXPosition () const
| Get the window's X position.
const UDim & | getYPosition () const
| Get the window's Y position.
UVector2 | getSize () const
| Get the window's size.
UDim | getWidth () const
| Get the window's width.
UDim | getHeight () const
| Get the window's height.
const UVector2 & | getMaxSize () const
| Get the window's maximum size.
const UVector2 & | getMinSize () const
| Get the window's minimum size.
void | render ()
| Causes the Window object to render itself and all of it's attached children.
virtual void | update (float elapsed)
| Cause window to update itself and any attached children. Client code does not need to call this method; to ensure full, and proper updates, call the injectTimePulse methodname method provided by the System class.
virtual void | writeXMLToStream (XMLSerializer &xml_stream) const
| Writes an xml representation of this window object to out_stream.
virtual void | beginInitialisation (void)
| Sets the internal 'initialising' flag to true. This can be use to optimize initialisation of some widgets, and is called automatically by the layout XML handler when it has created a window. That is just after the window has been created, but before any children or properties are read.
virtual void | endInitialisation (void)
| Sets the internal 'initialising' flag to false. This is called automatically by the layout XML handler when it is done creating a window. That is after all properties and children have been loaded and just before the next sibling gets created.
void | setMousePassThroughEnabled (bool setting)
| Sets whether this window should ignore mouse events and pass them through to any windows behind it. In effect making the window transparent to the mouse.
void | setWindowRenderer (const String &name)
| Assign the WindowRenderer to specify the Look'N'Feel specification to be used.
WindowRenderer * | getWindowRenderer (void) const
| Get the currently assigned WindowRenderer. (Look'N'Feel specification).
String | getWindowRendererName (void) const
| Get the factory name of the currently assigned WindowRenderer. (Look'N'Feel specification).
void | setWritingXMLAllowed (bool allow)
| Sets whether this window is allowed to write XML.
void | notifyScreenAreaChanged (bool recursive=true)
| Inform the window, and optionally all children, that screen area rectangles have changed.
void | setFalagardType (const String &type, const String &rendererType="")
| Changes the widget's falagard type, thus changing its look'n'feel and optionally its renderer in the process.
void | setDragDropTarget (bool setting)
| Specifies whether this Window object will receive events generated by the drag and drop support in the system.
void | setRenderingSurface (RenderingSurface *surface)
| Set the RenderingSurface to be associated with this Window, or 0 if none is required.
void | invalidateRenderingSurface ()
| Invalidate the chain of rendering surfaces from this window backwards to ensure they get properly redrawn - but doing the minimum amount of work possibe - next render.
void | setUsingAutoRenderingSurface (bool setting)
| Sets whether automatic use of an imagery caching RenderingSurface (i.e. a RenderingWindow) is enabled for this window. The reason we emphasise 'atutomatic' is because the client may manually set a RenderingSurface that does exactlythe same job.
void | setRotation (const Vector3 &rotation)
| set the rotations for this window.
void | setNonClientWindow (const bool setting)
| Set whether the Window is a non-client window.
const RenderedString & | getRenderedString () const
| Return the parsed RenderedString object for this window.
RenderedStringParser * | getCustomRenderedStringParser () const
| Return a pointer to any custom RenderedStringParser set, or 0 if none.
void | setCustomRenderedStringParser (RenderedStringParser *parser)
| Set a custom RenderedStringParser, or 0 to remove an existing one.
virtual RenderedStringParser & | getRenderedStringParser () const
| return the active RenderedStringParser to be used
bool | isTextParsingEnabled () const
| return whether text parsing is enabled for this window.
void | setTextParsingEnabled (const bool setting)
| set whether text parsing is enabled for this window.
virtual void | setMargin (const UBox &margin)
| set margin
const UBox & | getMargin () const
| retrieves currently set margin
Vector2 | getUnprojectedPosition (const Vector2 &pos) const
| return Vector2 pos after being fully unprojected for this Window.
const BiDiVisualMapping * | getBiDiVisualMapping () const
| return the pointer to the BiDiVisualMapping for this window, if any.
void | banPropertyFromXML (const String &property_name)
| Add the named property to the XML ban list for this window.
void | unbanPropertyFromXML (const String &property_name)
| Remove the named property from the XML ban list for this window.
bool | isPropertyBannedFromXML (const String &property_name) const
| Return whether the named property is banned from XML.
void | banPropertyFromXML (const Property *property)
| Add the given property to the XML ban list for this window.
void | unbanPropertyFromXML (const Property *property)
| Remove the given property from the XML ban list for this window.
bool | isPropertyBannedFromXML (const Property *property) const
| Return whether the given property is banned from XML.
void | setUpdateMode (const WindowUpdateMode mode)
| Set the window update mode. This mode controls the behaviour of the Window::update member function such that updates are processed for this window (and therefore it's child content) according to the set mode.
WindowUpdateMode | getUpdateMode () const
| Return the current window update mode that is set for this Window. This mode controls the behaviour of the Window::update member function such that updates are processed for this window (and therefore it's child content) according to the set mode.
void | setMouseInputPropagationEnabled (const bool enabled)
| Set whether mouse input that is not directly handled by this Window (including it's event subscribers) should be propagated back to the Window's parent.
bool | isMouseInputPropagationEnabled () const
| Return whether mouse input that is not directly handled by this Window (including it's event subscribers) should be propagated back to the Window's parent.
Window * | clone (const String &newName, const bool deepCopy=true) const
| Clones this Window and returns the result.
virtual void | clonePropertiesTo (Window &target) const
| copies this widget's properties to given target widget
virtual void | cloneChildWidgetsTo (Window &target) const
| copies this widget's child widgets to given target widget
size_t | getZIndex () const
| Return the (visual) z index of the window on it's parent.
bool | isInFront (const Window &wnd) const
| Return whether /a this Window is in front of the given window.
bool | isBehind (const Window &wnd) const
| Return whether /a this Window is behind the given window.
## Static Public Member Functions
static Window * | getCaptureWindow (void)
| return the Window that currently has inputs captured.
## Static Public Attributes
static const String | EventNamespace
| Namespace for global events.
static const String | EventWindowUpdated
static const String | EventParentSized
static const String | EventSized
static const String | EventMoved
static const String | EventTextChanged
static const String | EventFontChanged
static const String | EventAlphaChanged
static const String | EventIDChanged
static const String | EventActivated
static const String | EventDeactivated
static const String | EventShown
static const String | EventHidden
static const String | EventEnabled
static const String | EventDisabled
static const String | EventClippedByParentChanged
static const String | EventDestroyedByParentChanged
static const String | EventInheritsAlphaChanged
static const String | EventAlwaysOnTopChanged
static const String | EventInputCaptureGained
static const String | EventInputCaptureLost
static const String | EventRenderingStarted
static const String | EventRenderingEnded
static const String | EventChildAdded
static const String | EventChildRemoved
static const String | EventDestructionStarted
static const String | EventZOrderChanged
static const String | EventDragDropItemEnters
static const String | EventDragDropItemLeaves
static const String | EventDragDropItemDropped
static const String | EventVerticalAlignmentChanged
static const String | EventHorizontalAlignmentChanged
static const String | EventWindowRendererAttached
static const String | EventWindowRendererDetached
static const String | EventRotated
static const String | EventNonClientChanged
static const String | EventTextParsingChanged
static const String | EventMarginChanged
static const String | EventMouseEntersArea
static const String | EventMouseLeavesArea
static const String | EventMouseEnters
static const String | EventMouseLeaves
static const String | EventMouseMove
static const String | EventMouseWheel
static const String | EventMouseButtonDown
static const String | EventMouseButtonUp
static const String | EventMouseClick
static const String | EventMouseDoubleClick
static const String | EventMouseTripleClick
static const String | EventKeyDown
static const String | EventKeyUp
static const String | EventCharacterKey
static const String | TooltipNameSuffix
| Widget name suffix for automatically created tooltip widgets.
static const String | AutoWidgetNameSuffix
| Something that all generated widgets will have in their names.
## Protected Types
typedef std::vector< Window * > | ChildList
| definition of type used for the list of attached child windows.
typedef std::map< String, String, String::FastLessCompare > | UserStringMap
| definition of type used for the UserString dictionary.
typedef std::set< String, String::FastLessCompare > | BannedXMLPropertySet
| definition of type used to track properties banned from writing XML.
## Protected Member Functions
virtual void | onSized (WindowEventArgs &e)
| Handler called when the window's size changes.
virtual void | onMoved (WindowEventArgs &e)
| Handler called when the window's position changes.
virtual void | onTextChanged (WindowEventArgs &e)
| Handler called when the window's text is changed.
virtual void | onFontChanged (WindowEventArgs &e)
| Handler called when the window's font is changed.
virtual void | onAlphaChanged (WindowEventArgs &e)
| Handler called when the window's alpha blend value is changed.
virtual void | onIDChanged (WindowEventArgs &e)
| Handler called when the window's client assigned ID is changed.
virtual void | onShown (WindowEventArgs &e)
| Handler called when the window is shown (made visible).
virtual void | onHidden (WindowEventArgs &e)
| Handler called when the window is hidden.
virtual void | onEnabled (WindowEventArgs &e)
| Handler called when the window is enabled.
virtual void | onDisabled (WindowEventArgs &e)
| Handler called when the window is disabled.
virtual void | onClippingChanged (WindowEventArgs &e)
| Handler called when the window's setting for being clipped by it's parent is changed.
virtual void | onParentDestroyChanged (WindowEventArgs &e)
| Handler called when the window's setting for being destroyed automatically be it's parent is changed.
virtual void | onInheritsAlphaChanged (WindowEventArgs &e)
| Handler called when the window's setting for inheriting alpha-blending is changed.
virtual void | onAlwaysOnTopChanged (WindowEventArgs &e)
| Handler called when the window's always-on-top setting is changed.
virtual void | onCaptureGained (WindowEventArgs &e)
| Handler called when this window gains capture of mouse inputs.
virtual void | onCaptureLost (WindowEventArgs &e)
| Handler called when this window loses capture of mouse inputs.
virtual void | onRenderingStarted (WindowEventArgs &e)
| Handler called when rendering for this window has started.
virtual void | onRenderingEnded (WindowEventArgs &e)
| Handler called when rendering for this window has ended.
virtual void | onZChanged (WindowEventArgs &e)
| Handler called when the z-order position of this window has changed.
virtual void | onDestructionStarted (WindowEventArgs &e)
| Handler called when this window's destruction sequence has begun.
virtual void | onActivated (ActivationEventArgs &e)
| Handler called when this window has become the active window.
virtual void | onDeactivated (ActivationEventArgs &e)
| Handler called when this window has lost input focus and has been deactivated.
virtual void | onParentSized (WindowEventArgs &e)
| Handler called when this window's parent window has been resized. If this window is the root / GUI Sheet window, this call will be made when the display size changes.
virtual void | onChildAdded (WindowEventArgs &e)
| Handler called when a child window is added to this window.
virtual void | onChildRemoved (WindowEventArgs &e)
| Handler called when a child window is removed from this window.
virtual void | onMouseEntersArea (MouseEventArgs &e)
| Handler called when the mouse cursor has entered this window's area.
virtual void | onMouseLeavesArea (MouseEventArgs &e)
| Handler called when the mouse cursor has left this window's area.
virtual void | onMouseEnters (MouseEventArgs &e)
| Handler called when the mouse cursor has entered this window's area and is actually over some part of this windows surface and not, for instance over a child window - even though technically in those cases the mouse is also within this Window's area, the handler will not be called.
virtual void | onMouseLeaves (MouseEventArgs &e)
| Handler called when the mouse cursor is no longer over this window's surface area. This will be called when the mouse is not over a part of this Window's actual surface - even though technically the mouse is still within the Window's area, for example if the mouse moves over a child window.
virtual void | onMouseMove (MouseEventArgs &e)
| Handler called when the mouse cursor has been moved within this window's area.
virtual void | onMouseWheel (MouseEventArgs &e)
| Handler called when the mouse wheel (z-axis) position changes within this window's area.
virtual void | onMouseButtonDown (MouseEventArgs &e)
| Handler called when a mouse button has been depressed within this window's area.
virtual void | onMouseButtonUp (MouseEventArgs &e)
| Handler called when a mouse button has been released within this window's area.
virtual void | onMouseClicked (MouseEventArgs &e)
| Handler called when a mouse button has been clicked (that is depressed and then released, within a specified time) within this window's area.
virtual void | onMouseDoubleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been double-clicked within this window's area.
virtual void | onMouseTripleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been triple-clicked within this window's area.
virtual void | onKeyDown (KeyEventArgs &e)
| Handler called when a key as been depressed while this window has input focus.
virtual void | onKeyUp (KeyEventArgs &e)
| Handler called when a key as been released while this window has input focus.
virtual void | onCharacter (KeyEventArgs &e)
| Handler called when a character-key has been pressed while this window has input focus.
virtual void | onDragDropItemEnters (DragDropEventArgs &e)
| Handler called when a DragContainer is dragged over this window.
virtual void | onDragDropItemLeaves (DragDropEventArgs &e)
| Handler called when a DragContainer is dragged over this window.
virtual void | onDragDropItemDropped (DragDropEventArgs &e)
| Handler called when a DragContainer is dragged over this window.
virtual void | onVerticalAlignmentChanged (WindowEventArgs &e)
| Handler called when the vertical alignment setting for the window is changed.
virtual void | onHorizontalAlignmentChanged (WindowEventArgs &e)
| Handler called when the horizontal alignment setting for the window is changed.
virtual void | onWindowRendererAttached (WindowEventArgs &e)
| Handler called when a new window renderer object is attached.
virtual void | onWindowRendererDetached (WindowEventArgs &e)
| Handler called when the currently attached window renderer object is detached.
virtual void | onRotated (WindowEventArgs &e)
| Handler called when the window's rotation factor is changed.
virtual void | onNonClientChanged (WindowEventArgs &e)
| Handler called when the window's non-client setting, affecting it's position and size relative to it's parent is changed.
virtual void | onTextParsingChanged (WindowEventArgs &e)
| Handler called when the window's setting for whether text parsing is enabled is changed.
virtual void | onMarginChanged (WindowEventArgs &e)
virtual void | updateSelf (float elapsed)
| Perform actual update processing for this Window.
virtual void | drawSelf (const RenderingContext &ctx)
| Perform the actual rendering for this Window.
void | bufferGeometry (const RenderingContext &ctx)
| Perform drawing operations concerned with generating and buffering window geometry.
void | queueGeometry (const RenderingContext &ctx)
| Perform drawing operations concerned with positioning, clipping and queueing of window geometry to RenderingSurfaces.
virtual void | populateGeometryBuffer ()
| Update the rendering cache.
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance hierarchy.
void | setParent (Window *parent)
| Set the parent window for this window object.
Size | getSize_impl (const Window *window) const
void | generateAutoRepeatEvent (MouseButton button)
| Fires off a repeated mouse button down event for this window.
virtual bool | validateWindowRenderer (const String &name) const
| Function used in checking if a WindowRenderer is valid for this window.
bool | isPropertyAtDefault (const Property *property) const
| Returns whether a property is at it's default value. This function is different from Property::isDefatult as it takes the assigned look'n'feel (if the is one) into account.
void | notifyClippingChanged (void)
| Recursively inform all children that the clipping has changed and screen rects needs to be recached.
void | allocateRenderingWindow ()
| helper to create and setup the auto RenderingWindow surface
void | releaseRenderingWindow ()
| helper to clean up the auto RenderingWindow surface
void | initialiseClippers (const RenderingContext &ctx)
| Helper to intialise the needed clipping for geometry and render surface.
virtual void | cleanupChildren (void)
| Cleanup child windows.
virtual void | addChild_impl (Window *wnd)
| Add given window to child list at an appropriate position.
virtual void | removeChild_impl (Window *wnd)
| Remove given window from child list.
virtual void | onZChange_impl (void)
| Notify 'this' and all siblings of a ZOrder change event.
void | addStandardProperties (void)
| Add standard CEGUI::Window properties.
virtual bool | moveToFront_impl (bool wasClicked)
| Implements move to front behavior.
void | setArea_impl (const UVector2 &pos, const UVector2 &size, bool topLeftSizing=false, bool fireEvents=true)
| Implementation method to modify window area while correctly applying min / max size processing, and firing any appropriate events.
void | addWindowToDrawList (Window &wnd, bool at_back=false)
| Add the given window to the drawing list at an appropriate position for it's settings and the required direction. Basically, when at_back is false, the window will appear in front of all other windows with the same 'always on top' setting. When at_back is true, the window will appear behind all other windows wih the same 'always on top' setting.
void | removeWindowFromDrawList (const Window &wnd)
| Removes the window from the drawing list. If the window is not attached to the drawing list then nothing happens.
bool | isTopOfZOrder () const
| Return whether the window is at the top of the Z-Order. This will correctly take into account 'Always on top' windows as needed.
void | updateGeometryRenderSettings ()
| Update position and clip region on this Windows geometry / rendering surface.
void | transferChildSurfaces ()
| transfer RenderingSurfaces to be owned by our target RenderingSurface.
Rect | getParentElementClipIntersection (const Rect &unclipped_area) const
| helper function for calculating clipping rectangles.
void | invalidate_impl (const bool recursive)
| helper function to invalidate window and optionally child windows.
bool | isInnerRectSizeChanged () const
| helper to return whether the inner rect size has changed
const Window * | getWindowAttachedToCommonAncestor (const Window &wnd) const
| Helper function to return the ancestor Window of /a wnd that is attached as a child to a window that is also an ancestor of /a this. Returns 0 if /a wnd and /a this are not part of the same hierachy.
virtual Rect | getUnclippedOuterRect_impl () const
| Default implementation of function to return Window outer rect area.
virtual Rect | getOuterRectClipper_impl () const
| Default implementation of function to return Window outer clipper area.
virtual Rect | getInnerRectClipper_impl () const
| Default implementation of function to return Window inner clipper area.
virtual Rect | getHitTestRect_impl () const
| Default implementation of function to return Window hit-test area.
virtual Rect | getNonClientChildWindowContentArea_impl () const
| Default implementation of function to return non-client content area.
virtual Rect | getClientChildWindowContentArea_impl () const
| Default implementation of function to return client content area.
virtual int | writePropertiesXML (XMLSerializer &xml_stream) const
virtual int | writeChildWindowsXML (XMLSerializer &xml_stream) const
virtual bool | writeAutoChildWindowXML (XMLSerializer &xml_stream) const
bool | constrainUVector2ToMinSize (const Size &base_sz, UVector2 &sz)
bool | constrainUVector2ToMaxSize (const Size &base_sz, UVector2 &sz)
## Protected Attributes
const String | d_type
| type of Window (also the name of the WindowFactory that created us)
String | d_name
| The name of the window (GUI system unique).
String | d_falagardType
| Type name of the window as defined in a Falagard mapping.
bool | d_autoWindow
| true when this window is an auto-window (it's name contains __auto_)
bool | d_initialising
| true when this window is currently being initialised (creating children etc)
bool | d_destructionStarted
| true when this window is being destroyed.
bool | d_enabled
| true when Window is enabled
bool | d_visible
| is window visible (i.e. it will be rendered, but may still be obscured)
bool | d_active
| true when Window is the active Window (receiving inputs).
ChildList | d_children
| The list of child Window objects attached to this.
ChildList | d_drawList
| Child window objects arranged in rendering order.
Window * | d_parent
| Holds pointer to the parent window.
bool | d_destroyedByParent
| true when Window will be auto-destroyed by parent.
bool | d_clippedByParent
| true when Window will be clipped by parent Window area Rect.
bool | d_nonClientContent
| true if Window is in non-client (outside InnerRect) area of parent.
String | d_lookName
| Name of the Look assigned to this window (if any).
WindowRenderer * | d_windowRenderer
| The WindowRenderer module that implements the Look'N'Feel specification.
GeometryBuffer * | d_geometry
| Object which acts as a cache of geometry drawn by this Window.
RenderingSurface * | d_surface
| RenderingSurface owned by this window (may be 0)
bool | d_needsRedraw
| true if window geometry cache needs to be regenerated.
bool | d_autoRenderingWindow
| holds setting for automatic creation of of surface (RenderingWindow)
const Image * | d_mouseCursor
| Holds pointer to the Window objects current mouse cursor image.
float | d_alpha
| Alpha transparency setting for the Window.
bool | d_inheritsAlpha
| true if the Window inherits alpha from the parent Window
Window * | d_oldCapture
| The Window that previously had capture (used for restoreOldCapture mode)
bool | d_restoreOldCapture
| Restore capture to the previous capture window when releasing capture.
bool | d_distCapturedInputs
| Whether to distribute captured inputs to child windows.
Font * | d_font
| Holds pointer to the Window objects current Font.
String | d_textLogical
| Holds the text / label / caption for this Window.
BiDiVisualMapping * | d_bidiVisualMapping
| pointer to bidirection support object
bool | d_bidiDataValid
| whether bidi visual mapping has been updated since last text change.
RenderedString | d_renderedString
| RenderedString representation of text string as ouput from a parser.
bool | d_renderedStringValid
| true if d_renderedString is valid, false if needs re-parse.
RenderedStringParser * | d_customStringParser
| Pointer to a custom (user assigned) RenderedStringParser object.
bool | d_textParsingEnabled
| true if use of parser other than d_defaultStringParser is enabled
UBox | d_margin
| Margin, only used when the Window is inside LayoutContainer class.
uint | d_ID
| User ID assigned to this Window.
void * | d_userData
| Holds pointer to some user assigned data.
UserStringMap | d_userStrings
| Holds a collection of named user string values.
bool | d_alwaysOnTop
| true if Window will be drawn on top of all other Windows
bool | d_riseOnClick
| whether window should rise in the z order when left clicked.
bool | d_zOrderingEnabled
| true if the Window responds to z-order change requests.
bool | d_wantsMultiClicks
| true if the Window wishes to hear about multi-click mouse events.
bool | d_mousePassThroughEnabled
| whether (most) mouse events pass through this window
bool | d_autoRepeat
| whether pressed mouse button will auto-repeat the down event.
float | d_repeatDelay
| seconds before first repeat event is fired
float | d_repeatRate
| secons between further repeats after delay has expired.
MouseButton | d_repeatButton
| button we're tracking for auto-repeat purposes.
bool | d_repeating
| implements repeating - is true after delay has elapsed,
float | d_repeatElapsed
| implements repeating - tracks time elapsed.
bool | d_dragDropTarget
| true if window will receive drag and drop related notifications
String | d_tooltipText
| Text string used as tip for this window.
Tooltip * | d_customTip
| Possible custom Tooltip for this window.
bool | d_weOwnTip
| true if this Window created the custom Tooltip.
bool | d_inheritsTipText
| whether tooltip text may be inherited from parent.
bool | d_allowWriteXML
| true if this window is allowed to write XML, false if not
BannedXMLPropertySet | d_bannedXMLProperties
| collection of properties not to be written to XML for this window.
URect | d_area
| This Window objects area as defined by a URect.
Size | d_pixelSize
| Current constrained pixel size of the window.
UVector2 | d_minSize
| current minimum size for the window.
UVector2 | d_maxSize
| current maximum size for the window.
HorizontalAlignment | d_horzAlign
| Specifies the base for horizontal alignment.
VerticalAlignment | d_vertAlign
| Specifies the base for vertical alignment.
Vector3 | d_rotation
| Rotation angles for this window.
Rect | d_outerUnclippedRect
| outer area rect in screen pixels
Rect | d_innerUnclippedRect
| inner area rect in screen pixels
Rect | d_outerRectClipper
| outer area clipping rect in screen pixels
Rect | d_innerRectClipper
| inner area clipping rect in screen pixels
Rect | d_hitTestRect
| area rect used for hit-testing agains this window
bool | d_outerUnclippedRectValid
bool | d_innerUnclippedRectValid
bool | d_outerRectClipperValid
bool | d_innerRectClipperValid
bool | d_hitTestRectValid
WindowUpdateMode | d_updateMode
| The mode to use for calling Window::update.
bool | d_propagateMouseInputs
| specifies whether mouse inputs should be propagated to parent(s)
## Static Protected Attributes
static WindowProperties::Alpha | d_alphaProperty
static WindowProperties::AlwaysOnTop | d_alwaysOnTopProperty
static WindowProperties::ClippedByParent | d_clippedByParentProperty
static WindowProperties::DestroyedByParent | d_destroyedByParentProperty
static WindowProperties::Disabled | d_disabledProperty
static WindowProperties::Font | d_fontProperty
static WindowProperties::ID | d_IDProperty
static WindowProperties::InheritsAlpha | d_inheritsAlphaProperty
static WindowProperties::MouseCursorImage | d_mouseCursorProperty
static WindowProperties::RestoreOldCapture | d_restoreOldCaptureProperty
static WindowProperties::Text | d_textProperty
static WindowProperties::Visible | d_visibleProperty
static WindowProperties::ZOrderChangeEnabled | d_zOrderChangeProperty
static WindowProperties::WantsMultiClickEvents | d_wantsMultiClicksProperty
static WindowProperties::MouseButtonDownAutoRepeat | d_autoRepeatProperty
static WindowProperties::AutoRepeatDelay | d_autoRepeatDelayProperty
static WindowProperties::AutoRepeatRate | d_autoRepeatRateProperty
static WindowProperties::DistributeCapturedInputs | d_distInputsProperty
static WindowProperties::CustomTooltipType | d_tooltipTypeProperty
static WindowProperties::Tooltip | d_tooltipProperty
static WindowProperties::InheritsTooltipText | d_inheritsTooltipProperty
static WindowProperties::RiseOnClick | d_riseOnClickProperty
static WindowProperties::VerticalAlignment | d_vertAlignProperty
static WindowProperties::HorizontalAlignment | d_horzAlignProperty
static WindowProperties::UnifiedAreaRect | d_unifiedAreaRectProperty
static WindowProperties::UnifiedPosition | d_unifiedPositionProperty
static WindowProperties::UnifiedXPosition | d_unifiedXPositionProperty
static WindowProperties::UnifiedYPosition | d_unifiedYPositionProperty
static WindowProperties::UnifiedSize | d_unifiedSizeProperty
static WindowProperties::UnifiedWidth | d_unifiedWidthProperty
static WindowProperties::UnifiedHeight | d_unifiedHeightProperty
static WindowProperties::UnifiedMinSize | d_unifiedMinSizeProperty
static WindowProperties::UnifiedMaxSize | d_unifiedMaxSizeProperty
static WindowProperties::MousePassThroughEnabled | d_mousePassThroughEnabledProperty
static WindowProperties::WindowRenderer | d_windowRendererProperty
static WindowProperties::LookNFeel | d_lookNFeelProperty
static WindowProperties::DragDropTarget | d_dragDropTargetProperty
static WindowProperties::AutoRenderingSurface | d_autoRenderingSurfaceProperty
static WindowProperties::Rotation | d_rotationProperty
static WindowProperties::XRotation | d_xRotationProperty
static WindowProperties::YRotation | d_yRotationProperty
static WindowProperties::ZRotation | d_zRotationProperty
static WindowProperties::NonClient | d_nonClientProperty
static WindowProperties::TextParsingEnabled | d_textParsingEnabledProperty
static WindowProperties::Margin | d_marginProperty
static WindowProperties::UpdateMode | d_updateModeProperty
static WindowProperties::MouseInputPropagationEnabled | d_mouseInputPropagationProperty
static Window * | d_captureWindow
| Window that has captured inputs.
static BasicRenderedStringParser | d_basicStringParser
| Shared instance of a parser to be used in most instances.
static DefaultRenderedStringParser | d_defaultStringParser
| Shared instance of a parser to be used when rendering text verbatim.
## Friends
class | System
class | WindowManager

## Detailed Description

An abstract base class providing common functionality and specifying the required interface for derived classes.

The Window base class is core UI object class that the the system knows about; for this reason, every other window, widget, or similar item within the system must be derived from Window.

The base class provides the common functionality required by all UI objects, and specifies the minimal interface required to be implemented by derived classes.

## Constructor & Destructor Documentation

CEGUI::Window::Window | ( | const String & | type,
|  | const String & | name
| ) |  |

Constructor for Window base class.

Parameters:

  type | String object holding Window type (usually provided by WindowFactory).
  name | String object holding unique name for the Window.

## Member Function Documentation

void CEGUI::Window::activate | ( | void |  | ) |

Activate the Window giving it input focus and bringing it to the top of all windows with the same always-on-top settig as this Window.

Returns:
  Nothing

void CEGUI::Window::addChildWindow | ( | const String & | name | ) |

Add the named Window as a child of this Window. If the Window name is already attached to a Window, it is detached before being added to this Window.

Parameters:

  name | String object holding the name of the Window to be added.

Returns:
  Nothing.

Exceptions:

  UnknownObjectException | thrown if no Window named name exists.
  InvalidRequestException | thrown if Window name is an ancestor of this Window, to prevent cyclic Window structures.

void CEGUI::Window::addChildWindow | ( | Window * | window | ) |

Add the specified Window as a child of this Window. If the Window window is already attached to a Window, it is detached before being added to this Window.

Parameters:

  window | Pointer to the Window object to be added.

Returns:
  Nothing

Exceptions:

  InvalidRequestException | thrown if Window window is an ancestor of this Window, to prevent cyclic Window structures.

void CEGUI::Window::addWindowToDrawList | ( | Window & | wnd,
|  | bool | at_back = `false`
| ) |  | `[protected]`

Add the given window to the drawing list at an appropriate position for it's settings and the required direction. Basically, when at_back is false, the window will appear in front of all other windows with the same 'always on top' setting. When at_back is true, the window will appear behind all other windows wih the same 'always on top' setting.

Parameters:

  wnd | Window object to be added to the drawing list.
  at_back | Indicates whether the window should be placed at the back of other windows in the same group. If this is false, the window is placed in front of other windows in the group.

Returns:
  Nothing.

void CEGUI::Window::appendText | ( | const String & | text | ) |

Append the string text to the currect text string for the Window object.

Parameters:

  text | String object holding the text that is to be appended to the Window object's current text string.

void CEGUI::Window::bufferGeometry | ( | const RenderingContext & | ctx | ) | `[protected]`

Perform drawing operations concerned with generating and buffering window geometry.

Note:
  This function is a sub-function of drawSelf; it is provided to make it easier to override drawSelf without needing to duplicate large sections of the code from the default implementation.

bool CEGUI::Window::captureInput | ( | void |  | ) |

Captures input to this window.

Returns:
  - true if input was successfully captured to this window.
  - false if input could not be captured to this window (maybe because the window is not active).

Window* CEGUI::Window::clone | ( | const String & | newName,
|  | const bool | deepCopy = `true`
| ) |  | const

Clones this Window and returns the result.

Parameters:

  newName | new name of the cloned window
  deepCopy | if true, even children are copied (the old name prefix will be replaced with new name prefix)

Returns:
  the cloned Window

void CEGUI::Window::deactivate | ( | void |  | ) |

Deactivate the window. No further inputs will be received by the window until it is re-activated either programmatically or by the user interacting with the gui.

Returns:
  Nothing.

virtual void CEGUI::Window::destroy | ( | void |  | ) | `[virtual]`

Internal destroy method which actually just adds the window and any parent destructed child windows to the dead pool.

This is virtual to allow for specialised cleanup which may be required in some advanced cases. If you override this for the above reason, you MUST call this base class version.

Note:
  You never have to call this method yourself, use WindowManager to destroy your Window objects (which will call this for you).

Reimplemented in CEGUI::ScrollablePane.

void CEGUI::Window::disable | ( | void |  | ) | `[inline]`

disable the Window to prevent interaction.

Returns:
  Nothing

bool CEGUI::Window::distributesCapturedInputs | ( | void |  | ) | const

Return whether the window wants inputs passed to its attached child windows when the window has inputs captured.

Returns:
  - true if System should pass captured input events to child windows.
  - false if System should pass captured input events to this window only.

virtual void CEGUI::Window::drawSelf | ( | const RenderingContext & | ctx | ) | `[protected, virtual]`

Perform the actual rendering for this Window.

Parameters:

  ctx | RenderingContext holding the details of the RenderingSurface to be used for the Window rendering operations.

Returns:
  Nothing

Reimplemented in CEGUI::ClippedContainer, CEGUI::ScrolledContainer, and CEGUI::TabControl.

void CEGUI::Window::enable | ( | void |  | ) | `[inline]`

enable the Window to allow interaction.

Returns:
  Nothing

Window* CEGUI::Window::getActiveChild | ( | void |  | ) |

return a pointer to the Window that currently has input focus starting with this Window.

Returns:
  Pointer to the window that is active (has input focus) starting at this window. The function will return 'this' if this Window is active and either no children are attached or if none of the attached children are active. Returns NULL if this Window (and therefore all children) are not active.

Window* CEGUI::Window::getActiveSibling | ( |  | ) |

Returns the active sibling window.

This searches the immediate children of this window's parent, and returns a pointer to the active window. The method will return this if we are the immediate child of our parent that is active. If our parent is not active, or if no immediate child of our parent is active then 0 is returned. If this window has no parent, and this window is not active then 0 is returned, else this is returned.

Returns:
  A pointer to the immediate child window attached to our parent that is currently active, or 0 if no immediate child of our parent is active.

float CEGUI::Window::getAlpha | ( | void |  | ) | const`[inline]`

return the current alpha value set for this Window

Note:
  The alpha value set for any given window may or may not be the final alpha value that is used when rendering. All window objects, by default, inherit alpha from thier parent window(s) - this will blend child windows, relatively, down the line of inheritance. This behaviour can be overridden via the setInheritsAlpha() method. To return the true alpha value that will be applied when rendering, use the getEffectiveAlpha() method.

Returns:
  the currently set alpha value for this Window. The value returned Will be between 0.0f and 1.0f.

const URect& CEGUI::Window::getArea | ( |  | ) | const

Return the windows area.

Returns the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  URect describing the rectangle of the window area.

float CEGUI::Window::getAutoRepeatDelay | ( | void |  | ) | const

Return the current auto-repeat delay setting for this window.

Returns:
  float value indicating the delay, in seconds, defore the first repeat mouse button down event will be triggered when autorepeat is enabled.

float CEGUI::Window::getAutoRepeatRate | ( | void |  | ) | const

Return the current auto-repeat rate setting for this window.

Returns:
  float value indicating the rate, in seconds, at which repeat mouse button down events will be generated after the initial delay has expired.

static Window* CEGUI::Window::getCaptureWindow | ( | void |  | ) | `[inline, static]`

return the Window that currently has inputs captured.

Returns:
  Pointer to the Window object that currently has inputs captured, or NULL if no Window has captured input.

Window* CEGUI::Window::getChild | ( | const String & | name | ) | const

return a pointer to the child window with the specified name.

This function will throw an exception if no child object with the given name is attached. This decision was made (over returning NULL if no window was found) so that client code can assume that if the call returns it has a valid window pointer. We provide the isChild() functions for checking if a given window is attached.

Parameters:

  name | String object holding the name of the child window for which a pointer is to be returned.

Returns:
  Pointer to the Window object attached to this window that has the name name.

Exceptions:

  UnknownObjectException | thrown if no window named name is attached to this Window.

Window* CEGUI::Window::getChild | ( | uint | ID | ) | const

return a pointer to the first attached child window with the specified ID value.

This function will throw an exception if no child object with the given ID is attached. This decision was made (over returning NULL if no window was found) so that client code can assume that if the call returns it has a valid window pointer. We provide the isChild() functions for checking if a given window is attached.

Parameters:

  ID | uint value specifying the ID code of the window to return a pointer to.

Returns:
  Pointer to the (first) Window object attached to this window that has the ID code ID.

Exceptions:

  UnknownObjectException | thrown if no window with the ID code ID is attached to this Window.

Window* CEGUI::Window::getChildAtIdx | ( | size_t | idx | ) | const`[inline]`

return a pointer to the child window that is attached to 'this' at the given index.

Parameters:

  idx | Index of the child window whos pointer should be returned. This value is not bounds checked, client code should ensure that this is less than the value returned by getChildCount().

Returns:
  Pointer to the child window currently attached at index position idx

Window* CEGUI::Window::getChildAtPosition | ( | const Vector2 & | position | ) | const

return the child Window that is hit by the given pixel position

Parameters:

  position | Vector2 object describing the position to check. The position describes a pixel offset from the top-left corner of the display.

Returns:
  Pointer to the child Window that was hit according to the location position, or 0 if no child of this window was hit.

size_t CEGUI::Window::getChildCount | ( | void |  | ) | const`[inline]`

return the number of child Window objects currently attached to this Window.

Returns:
  size_t value equal to the number of Window objects directly attached to this Window as children.

Window* CEGUI::Window::getChildRecursive | ( | const String & | name | ) | const

return a pointer to the first attached child window with the specified name. Children are traversed recursively.

Contrary to the non recursive version of this function, this one will not throw an exception, but return 0 in case no child was found.

Note:
  WARNING! This function can be very expensive and should only be used when you have no other option available. If you decide to use it anyway, make sure the window hierarchy from the entry point is small.

Parameters:

  name | String object holding the name of the child window for which a pointer is to be returned.

Returns:
  Pointer to the Window object attached to this window that has the name name.

If no child is found with the name name, 0 is returned.

Window* CEGUI::Window::getChildRecursive | ( | uint | ID | ) | const

return a pointer to the first attached child window with the specified ID value. Children are traversed recursively.

Contrary to the non recursive version of this function, this one will not throw an exception, but return 0 in case no child was found.

Note:
  WARNING! This function can be very expensive and should only be used when you have no other option available. If you decide to use it anyway, make sure the window hierarchy from the entry point is small.

Parameters:

  ID | uint value specifying the ID code of the window to return a pointer to.

Returns:
  Pointer to the (first) Window object attached to this window that has the ID code ID. If no child is found with the ID code ID, 0 is returned.

Rect CEGUI::Window::getChildWindowContentArea | ( | const bool | non_client = `false` | ) | const

Return a Rect that describes the area that is used to position and - for scale values - size child content attached to this Window.

By and large the area returned here will be the same as the unclipped inner rect (for client content) or the unclipped outer rect (for non client content), although certain advanced uses will require alternative Rects to be returned.

Note:
  The behaviour of this function is modified by overriding the protected Window::getClientChildWindowContentArea_impl and/or Window::getNonClientChildWindowContentArea_impl functions.

Parameters:

  non_client | true to return the non-client child content area. false to return the client child content area (default).

Rect CEGUI::Window::getClipRect | ( | const bool | non_client = `false` | ) | const

Return a Rect that describes the rendering clipping rect for the Window.

This function can return the clipping rect for either the inner or outer area dependant upon the boolean values passed in.

Note:
  The areas returned by this function gives you the correct clipping rects for rendering within the Window's areas. The area described may or may not correspond to the final visual clipping actually seen on the display; this is intentional and neccessary due to the way that imagery is cached under some configurations.

Parameters:

  non_client | true to return the non-client clipping area (based on outer rect). false to return the client clipping area (based on inner rect).

float CEGUI::Window::getEffectiveAlpha | ( | void |  | ) | const

return the effective alpha value that will be used when rendering this window, taking into account inheritance of parent window(s) alpha.

Returns:
  the effective alpha that will be applied to this Window when rendering. The value returned Will be between 0.0f and 1.0f.

EventSet::Iterator CEGUI::Window::getEventIterator | ( |  | ) | const

Helper method that returns an EventSet::Iterator object that can be used to iterate over the events currently added to the EventSet of this Window.

  This helper member is provided as an easy way to avoid some abiguity we have due to using multiple inheritence. Ultimately it avoids the need to do things like this (which some people don't like!):

              // obtain an iterator for the EventSet
              EventSet::Iterator evt_iter = myWindow->EventSet::getIterator();

              // obtain an iterator for the PropertySet
              PropertySet::Iterator prp_iter = myWindow->PropertySet::getIterator();

Note:
  Iterating over events in the EventSet is of questionable use these days, since available Events are no longer added in one batch at creation time, but are added individually whenever an event is first subscribed.

Returns:
  EventSet::Iterator object.

Font* CEGUI::Window::getFont | ( | bool | useDefault = `true` | ) | const

return the active Font object for the Window.

Parameters:

  useDefault | Sepcifies whether to return the default font if this Window has no preferred font set.

Returns:
  Pointer to the Font being used by this Window. If the window has no assigned font, and useDefault is true, then the default system font is returned.

GeometryBuffer& CEGUI::Window::getGeometryBuffer | ( |  | ) |

Return the GeometryBuffer object for this Window.

Returns:
  Reference to the GeometryBuffer object for this Window.

UDim CEGUI::Window::getHeight | ( |  | ) | const

Get the window's height.

Gets the height of the area occupied by this window.

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UDim describing the height of the window area.

Rect CEGUI::Window::getHitTestRect | ( |  | ) | const

Return the Rect that descibes the clipped screen area that is used for determining whether this window has been hit by a certain point.

The area returned by this function may also be useful for certain calculations that require the clipped Window area as seen on the display as opposed to what is used for rendering (since the actual rendering clipper rects should not to be used if reliable results are desired).

HorizontalAlignment CEGUI::Window::getHorizontalAlignment | ( |  | ) | const`[inline]`

Get the horizontal alignment.

Returns the horizontal alignment for the window. This setting affects how the windows position is interpreted relative to its parent.

Returns:
  One of the HorizontalAlignment enumerated values.

uint CEGUI::Window::getID | ( | void |  | ) | const`[inline]`

return the ID code currently assigned to this Window by client code.

Returns:
  uint value equal to the currently assigned ID code for this Window.

Rect CEGUI::Window::getInnerRectClipper | ( |  | ) | const

Return a Rect that describes the rendering clipping rect based upon the inner rect area of the window.

Note:
  The area returned by this function gives you the correct clipping rect for rendering within the Window's inner rect area. The area described may or may not correspond to the final visual clipping actually seen on the display; this is intentional and neccessary due to the way that imagery is cached under some configurations.

const String& CEGUI::Window::getLookNFeel | ( |  | ) | const

Get the name of the LookNFeel assigned to this window.

Returns:
  String object holding the name of the look assigned to this window. Returns the empty string if no look is assigned.

const UVector2& CEGUI::Window::getMaxSize | ( |  | ) | const

Get the window's maximum size.

Gets the maximum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UVector2 describing the maximum size of the window area.

const UVector2& CEGUI::Window::getMinSize | ( |  | ) | const

Get the window's minimum size.

Gets the minimum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UVector2 describing the minimum size of the window area.

bool CEGUI::Window::getModalState | ( | void |  | ) | const`[inline]`

Get whether or not this Window is the modal target.

Returns:
  Returns true if this Window is the modal target, otherwise false.

References CEGUI::System::getSingleton().

const Image* CEGUI::Window::getMouseCursor | ( | bool | useDefault = `true` | ) | const

Return a pointer to the mouse cursor image to use when the mouse cursor is within this window's area.

Parameters:

  useDefault | Sepcifies whether to return the default mouse cursor image if this window specifies no preferred mouse cursor image.

Returns:
  Pointer to the mouse cursor image that will be used when the mouse enters this window's area. May return NULL indicating no cursor will be drawn for this window.

const String& CEGUI::Window::getName | ( | void |  | ) | const`[inline]`

return a String object holding the name of this Window.

Returns:
  String object holding the unique Window name.

Rect CEGUI::Window::getOuterRectClipper | ( |  | ) | const

Return a Rect that describes the rendering clipping rect based upon the outer rect area of the window.

Note:
  The area returned by this function gives you the correct clipping rect for rendering within the Window's outer rect area. The area described may or may not correspond to the final visual clipping actually seen on the display; this is intentional and neccessary due to the way that imagery is cached under some configurations.

Window* CEGUI::Window::getParent | ( | void |  | ) | const`[inline]`

return the parent of this Window.

Returns:
  Pointer to the Window object that is the parent of this Window. This value can be NULL, in which case the Window is a GUI sheet / root.

float CEGUI::Window::getParentPixelHeight | ( | void |  | ) | const

Return the pixel Height of the parent element. This always returns a valid number.

Returns:
  float value that is equal to the pixel height of this Window objects parent

Size CEGUI::Window::getParentPixelSize | ( | void |  | ) | const

Return the pixel size of the parent element. This always returns a valid object.

Returns:
  Size object that describes the pixel dimensions of this Window objects parent

float CEGUI::Window::getParentPixelWidth | ( | void |  | ) | const

Return the pixel Width of the parent element. This always returns a valid number.

Returns:
  float value that is equal to the pixel width of this Window objects parent

Size CEGUI::Window::getPixelSize | ( | void |  | ) | const`[inline]`

Return the window size in pixels.

Returns:
  Size object describing this windows size in pixels.

const UVector2& CEGUI::Window::getPosition | ( |  | ) | const

Get the window's position.

Gets the position of the area occupied by this window. The position is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UVector2 describing the position (top-left corner) of the window area.

PropertySet::Iterator CEGUI::Window::getPropertyIterator | ( |  | ) | const

Helper method that returns a PropertySet::Iterator object that can be used to iterate over the events currently added to the PropertySet of this Window.

  This helper member is provided as an easy way to avoid some abiguity we have due to using multiple inheritence. Ultimately it avoids the need to do things like this (which some people don't like!):

              // obtain an iterator for the EventSet
              EventSet:: Iterator evt_iter = myWindow->EventSet::getIterator();

              // obtain an iterator for the PropertySet
              PropertySet::Iterator prp_iter = myWindow->PropertySet::getIterator();

Returns:
  PropertySet::Iterator object.

const Window* CEGUI::Window::getRootWindow | ( |  | ) | const

Returns the window at the root of the hierarchy starting at this Window. The root window is defined as the first window back up the hierarchy that has no parent window.

Returns:
  A pointer to the root window of the hierarchy that this window is attched to.

UVector2 CEGUI::Window::getSize | ( |  | ) | const

Get the window's size.

Gets the size of the area occupied by this window.

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UVector2 describing the size of the window area.

Window* CEGUI::Window::getTargetChildAtPosition | ( | const Vector2 & | position,
|  | const bool | allow_disabled = `false`
| ) |  | const

return the child Window that is 'hit' by the given position, and is allowed to handle mouse events.

Parameters:

  position | Vector2 object describing the position to check. The position describes a pixel offset from the top-left corner of the display.
  allow_disabled | true specifies that a disabled window may be returned as the target. false specifies that only enabled windows may be returned.

Returns:
  Pointer to the child Window that was hit according to the location position, or 0 if no child of this window was hit.

const String& CEGUI::Window::getText | ( | void |  | ) | const`[inline]`

return the current text for the Window

Returns:
  The String object that holds the current text for this Window.

Tooltip* CEGUI::Window::getTooltip | ( | void |  | ) | const

Return a pointer to the Tooltip object used by this Window. The value returned may point to the system default Tooltip, a custom Window specific Tooltip, or be NULL.

Returns:
  Pointer to a Tooltip based object, or NULL.

const String& CEGUI::Window::getTooltipText | ( | void |  | ) | const

Return the current tooltip text set for this Window.

Returns:
  String object holding the current tooltip text set for this window.

String CEGUI::Window::getTooltipType | ( | void |  | ) | const

Return the custom tooltip type.

Returns:
  String object holding the current custom tooltip window type, or an empty string if no custom tooltip is set.

const String& CEGUI::Window::getType | ( | void |  | ) | const

return a String object holding the type name for this Window.

Returns:
  String object holding the Window type.

virtual Rect CEGUI::Window::getUnclippedInnerRect_impl | ( | void |  | ) | const`[virtual]`

Return a Rect object that describes, unclipped, the inner rectangle for this window. The inner rectangle is typically an area that excludes some frame or other rendering that should not be touched by subsequent rendering.

Returns:
  Rect object that describes, in unclipped screen pixel co-ordinates, the window object's inner rect area.

Note:
  This function is going to change from public visibility to pretected. All code accessing the area rects via external code should be using the regular getUnclippedInnerRect function.

Reimplemented in CEGUI::ClippedContainer, CEGUI::LayoutContainer, and CEGUI::ScrolledContainer.

Rect CEGUI::Window::getUnclippedRect | ( | const bool | inner | ) | const

Return a Rect that describes the unclipped area covered by the Window.

This function can return either the inner or outer area dependant upon the boolean values passed in.

Parameters:

  inner | true if the inner rect area should be returned. false if the outer rect area should be returned.

WindowUpdateMode CEGUI::Window::getUpdateMode | ( |  | ) | const

Return the current window update mode that is set for this Window. This mode controls the behaviour of the Window::update member function such that updates are processed for this window (and therefore it's child content) according to the set mode.

Note:
  Disabling updates can have negative effects on the behaviour of CEGUI windows and widgets; updates should be disabled selectively and cautiously - if you are unsure of what you are doing, leave the mode set to WUM_ALWAYS.

Returns:
  One of the WindowUpdateMode enumerated values indicating the current mode set for this Window.

void* CEGUI::Window::getUserData | ( | void |  | ) | const`[inline]`

Return the user data set for this Window.

Each Window can have some client assigned data attached to it, this data is not used by the GUI system in any way. Interpretation of the data is entirely application specific.

Returns:
  pointer to the user data that is currently set for this window.

const String& CEGUI::Window::getUserString | ( | const String & | name | ) | const

Returns a named user string.

Parameters:

  name | String object holding the name of the string to be returned.

Returns:
  String object holding the data stored for the requested user string.

Exceptions:

  UnknownObjectException | thrown if a user string named name does not exist.

VerticalAlignment CEGUI::Window::getVerticalAlignment | ( |  | ) | const`[inline]`

Get the vertical alignment.

Returns the vertical alignment for the window. This setting affects how the windows position is interpreted relative to its parent.

Returns:
  One of the VerticalAlignment enumerated values.

UDim CEGUI::Window::getWidth | ( |  | ) | const

Get the window's width.

Gets the width of the area occupied by this window.

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UDim describing the width of the window area.

WindowRenderer* CEGUI::Window::getWindowRenderer | ( | void |  | ) | const

Get the currently assigned WindowRenderer. (Look'N'Feel specification).

Returns:
  A pointer to the assigned window renderer object. 0 if no window renderer is assigned.

String CEGUI::Window::getWindowRendererName | ( | void |  | ) | const

Get the factory name of the currently assigned WindowRenderer. (Look'N'Feel specification).

Returns:
  The factory name of the currently assigned WindowRenderer. If no WindowRenderer is assigned an empty string is returned.

const UDim& CEGUI::Window::getXPosition | ( |  | ) | const

Get the window's X position.

Gets the x position (left edge) of the area occupied by this window. The position is offset from the left edge of this windows parent window or from the left edge of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UDim describing the x position of the window area.

const UDim& CEGUI::Window::getYPosition | ( |  | ) | const

Get the window's Y position.

Gets the y position (top edge) of the area occupied by this window. The position is offset from the top edge of this windows parent window or from the top edge of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Returns:
  UDim describing the y position of the window area.

size_t CEGUI::Window::getZIndex | ( |  | ) | const

Return the (visual) z index of the window on it's parent.

The z index is a number that indicates the order that windows will be drawn (but is not a 'z co-ordinate', as such). Higher numbers are in front of lower numbers.

The number returned will not be stable, and generally should be used to compare with the z index of sibling windows (and only sibling windows) to discover the current z ordering of those windows.

void CEGUI::Window::hide | ( | void |  | ) | `[inline]`

hide the Window.

Note:
  If the window is the active window, it will become deactivated as a result of being hidden.

Returns:
  Nothing

bool CEGUI::Window::inheritsAlpha | ( | void |  | ) | const`[inline]`

return true if the Window inherits alpha from its parent(s).

Returns:
  - true if the Window inherits alpha from its parent(s)
  - false if the alpha for this Window is independant from its parents.

bool CEGUI::Window::inheritsTooltipText | ( | void |  | ) | const

Return whether this window inherits Tooltip text from its parent when its own tooltip text is not set.

Returns:
  - true if the window inherits tooltip text from its parent when its own text is not set.
  - false if the window does not inherit tooltip text from its parent (and shows no tooltip when no text is set).

virtual void CEGUI::Window::initialiseComponents | ( | void |  | ) | `[inline, virtual]`

Initialises the Window based object ready for use.

Note:
  This must be called for every window created. Normally this is handled automatically by the WindowManager.

Returns:
  Nothing

Reimplemented in CEGUI::Combobox, CEGUI::ComboDropList, CEGUI::FrameWindow, CEGUI::GroupBox, CEGUI::ItemListBase, CEGUI::ItemListbox, CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::ScrolledItemListBase, CEGUI::Slider, CEGUI::Spinner, and CEGUI::TabControl.

void CEGUI::Window::insertText | ( | const String & | text,
|  | const String::size_type | position
| ) |  |

Insert the text string text into the current text string for the Window object at the position specified by position.

Parameters:

  text | String object holding the text that is to be inserted into the Window object's current text string.
  position | The characted index position where the string text should be inserted.

void CEGUI::Window::invalidate | ( | void |  | ) |

Invalidate this window causing at least this window to be redrawn during the next rendering pass.

Returns:
  Nothing

Deprecated:
  This function is deprecated in favour of the version taking a boolean.

void CEGUI::Window::invalidate | ( | const bool | recursive | ) |

Invalidate this window and - dependant upon recursive - all child content, causing affected windows to be redrawn during the next rendering pass.

Parameters:

  recursive | Boolean value indicating whether attached child content should also be invalidated. true will cause all child content to be invalidated also. false will just invalidate this single window.

Returns:
  Nothing

bool CEGUI::Window::isActive | ( | void |  | ) | const

return true if this is the active Window. An active window is a window that may receive user inputs.

Mouse events are always sent to the window containing the mouse cursor regardless of what this function reports (unless a window has captured inputs). The active state mainly determines where send other, for example keyboard, inputs.

Returns:
  - true if the window is active and may be sent inputs by the system.
  - false if the window is inactive and will not be sent inputs.

bool CEGUI::Window::isAlwaysOnTop | ( | void |  | ) | const`[inline]`

returns whether or not this Window is an always on top Window. Also known as a top-most window.

Returns:
  - true if this Window is always drawn on top of other normal windows.
  - false if the Window has normal z-order behaviour.

bool CEGUI::Window::isAncestor | ( | const String & | name | ) | const

return true if the specified Window is some ancestor of this Window

Parameters:

  name | String object holding the name of the Window to check for.

Returns:
  - true if a Window named name is an ancestor (parent, or parent of parent, etc) of this Window.
  - false if a Window named name is in no way an ancestor of this window.

bool CEGUI::Window::isAncestor | ( | uint | ID | ) | const

return true if any Window with the given ID is some ancestor of this Window.

Parameters:

  ID | uint value specifying the ID to look for.

Returns:
  - true if an ancestor (parent, or parent of parent, etc) was found with the ID code ID.
  - false if no ancestor window has the ID code ID.

bool CEGUI::Window::isAncestor | ( | const Window * | window | ) | const

return true if the specified Window is some ancestor of this Window.

Parameters:

  window | Pointer to the Window object to look for.

Returns:
  - true if window was found to be an ancestor (parent, or parent of parent, etc) of this Window.
  - false if window is not an ancestor of this window.

bool CEGUI::Window::isBehind | ( | const Window & | wnd | ) | const

Return whether /a this Window is behind the given window.

Note:
  Here 'behind' just means that one window is drawn before the other, it is not meant to imply that the windows are overlapping nor that one window is obscured by the other.

bool CEGUI::Window::isCapturedByAncestor | ( | void |  | ) | const`[inline]`

return true if an ancestor window has captured inputs.

Returns:
  - true if input is captured by a Window that is some ancestor (parent, parent of parent, etc) of this Window.
  - false if no ancestor of this window has captured input.

bool CEGUI::Window::isCapturedByChild | ( | void |  | ) | const`[inline]`

return true if a child window has captured inputs.

Returns:
  - true if input is captured by a Window that is a child of this Window.
  - false if no child of this window has not captured input.

bool CEGUI::Window::isCapturedByThis | ( | void |  | ) | const`[inline]`

return true if this Window has input captured.

Returns:
  - true if this Window has captured inputs.
  - false if some other Window, or no Window, has captured inputs.

bool CEGUI::Window::isChild | ( | const String & | name | ) | const

returns whether a Window with the specified name is currently attached to this Window as a child.

Parameters:

  name | String object containing the name of the Window to look for.

Returns:
  - true if a Window named name is currently attached to this Window.
  - false if no such child Window is attached.

bool CEGUI::Window::isChild | ( | uint | ID | ) | const

returns whether at least one window with the given ID code is attached to this Window as a child.

Note:
  ID codes are client assigned and may or may not be unique, and as such, the return from this function will only have meaning to the client code.

Parameters:

  ID | uint ID code to look for.

Returns:
  - true if at least one child window was found with the ID code ID
  - false if no child window was found with the ID code ID.

bool CEGUI::Window::isChild | ( | const Window * | window | ) | const

return true if the given Window is a child of this window.

Parameters:

  window | Pointer to the Window object to look for.

Returns:
  - true if Window object window is attached to this window as a child.
  - false if Window object window is not a child of this Window.

bool CEGUI::Window::isChildRecursive | ( | uint | ID | ) | const

returns whether at least one window with the given ID code is attached to this Window or any of it's children as a child.

Note:
  ID codes are client assigned and may or may not be unique, and as such, the return from this function will only have meaning to the client code.

WARNING! This function can be very expensive and should only be used when you have no other option available. If you decide to use it anyway, make sure the window hierarchy from the entry point is small.

Parameters:

  ID | uint ID code to look for.

Returns:
  - true if at least one child window was found with the ID code ID
  - false if no child window was found with the ID code ID.

bool CEGUI::Window::isClippedByParent | ( | void |  | ) | const`[inline]`

return true if this Window is clipped so that its rendering will not pass outside of its parent Window area.

Returns:
  - true if the window will be clipped by its parent Window.
  - false if the windows rendering may pass outside its parents area

bool CEGUI::Window::isDestroyedByParent | ( | void |  | ) | const`[inline]`

returns whether or not this Window is set to be destroyed when its parent window is destroyed.

Returns:
  - true if the Window will be destroyed when its parent is destroyed.
  - false if the Window will remain when its parent is destroyed.

bool CEGUI::Window::isDisabled | ( | bool | localOnly = `false` | ) | const

return whether the Window is currently disabled

Parameters:

  localOnly | States whether to only return the state set for this window, and not to factor in inherited state from ancestor windows.

Returns:
  - true if the window is disabled.
  - false if the window is enabled.

bool CEGUI::Window::isDragDropTarget | ( |  | ) | const

Returns whether this Window object will receive events generated by the drag and drop support in the system.

Returns:
  - true if the Window is enabled as a drag and drop target.
  - false if the window is not enabled as a drag and drop target.

virtual bool CEGUI::Window::isHit | ( | const Vector2 & | position,
|  | const bool | allow_disabled = `false`
| ) |  | const`[virtual]`

check if the given pixel position would hit this window.

Parameters:

  position | Vector2 object describing the position to check. The position describes a pixel offset from the top-left corner of the display.
  allow_disabled | true specifies that the window may be 'hit' if it is disabled. false specifies that the window may only be hit if it is enabled.

Returns:
  - true if position hits this Window.
  - false if position does not hit this window.

Reimplemented in CEGUI::Combobox, and CEGUI::FrameWindow.

Referenced by CEGUI::FrameWindow::isHit().

bool CEGUI::Window::isInFront | ( | const Window & | wnd | ) | const

Return whether /a this Window is in front of the given window.

Note:
  Here 'in front' just means that one window is drawn after the other, it is not meant to imply that the windows are overlapping nor that one window is obscured by the other.

bool CEGUI::Window::isMouseAutoRepeatEnabled | ( | void |  | ) | const

Return whether mouse button down event autorepeat is enabled for this window.

Returns:
  - true if autorepeat of mouse button down events is enabled for this window.
  - false if autorepeat of mouse button down events is not enabled for this window.

bool CEGUI::Window::isMouseInputPropagationEnabled | ( |  | ) | const

Return whether mouse input that is not directly handled by this Window (including it's event subscribers) should be propagated back to the Window's parent.

Returns:
  - true if unhandled mouse input will be propagated to the parent.
  - false if unhandled mouse input will not be propagated.

bool CEGUI::Window::isMousePassThroughEnabled | ( | void |  | ) | const`[inline]`

Returns whether this window should ignore mouse event and pass them through to and other windows behind it. In effect making the window transparent to the mouse.

Returns:
  true if mouse pass through is enabled. false if mouse pass through is not enabled.

bool CEGUI::Window::isNonClientWindow | ( |  | ) | const

Return whether the Window is a non-client window.

A non-client window is clipped, positioned and sized according to the parent window's full area as opposed to just the inner rect area used for normal client windows.

Returns:
  - true if the window should is clipped, positioned and sized according to the full area rectangle of it's parent.
  - false if the window is be clipped, positioned and sized according to the inner rect area of it's parent.

bool CEGUI::Window::isRiseOnClickEnabled | ( | void |  | ) | const`[inline]`

Return whether this window will rise to the top of the z-order when clicked with the left mouse button.

Note:
  This is distinguished from the is/setZOrderingEnabled setting in that if rise on click is disabled it only affects the users ability to affect the z order of the Window by clicking the mouse; is still possible to programatically alter the Window z-order by calling the moveToFront, moveToBack, moveInFront and moveBehind member functions. Whereas if z ordering is disabled those functions are also precluded from affecting the Window z position.

Returns:
  - true if the window will come to the top of other windows when the left mouse button is pushed within its area.
  - false if the window does not change z-order position when the left mouse button is pushed within its area.

bool CEGUI::Window::isTopOfZOrder | ( |  | ) | const`[protected]`

Return whether the window is at the top of the Z-Order. This will correctly take into account 'Always on top' windows as needed.

Returns:
  - true if the Window is at the top of the z-order in relation to sibling windows with the same 'always on top' setting.
  - false if the Window is not at the top of the z-order in relation to sibling windows with the same 'always on top' setting.

bool CEGUI::Window::isUserStringDefined | ( | const String & | name | ) | const

Return whether a user string with the specified name exists.

Parameters:

  name | String object holding the name of the string to be checked.

Returns:
  - true if a user string named name exists.
  - false if no such user string exists.

bool CEGUI::Window::isUsingAutoRenderingSurface | ( |  | ) | const

Returns whether automatic use of an imagery caching RenderingSurface (i.e. a RenderingWindow) is enabled for this window. The reason we emphasise 'automatic' is because the client may manually set a RenderingSurface that does exactly the same job.

Returns:
  - true if automatic use of a caching RenderingSurface is enabled.
  - false if automatic use of a caching RenderTarget is not enabled.

bool CEGUI::Window::isUsingDefaultTooltip | ( | void |  | ) | const

Return whether this Window is using the system default Tooltip for its Tooltip window.

Returns:
  - true if the Window will use the system default tooltip.
  - false if the window has a custom Tooltip object.

bool CEGUI::Window::isVisible | ( | bool | localOnly = `false` | ) | const

return true if the Window is currently visible.

When true is returned from this function does not mean that the window is not completely obscured by other windows, just that the window will be processed when rendering, and is not explicitly marked as hidden.

Parameters:

  localOnly | States whether to only return the state set for this window, and not to factor in inherited state from ancestor windows.

Returns:
  - true if the window will be drawn.
  - false if the window is hidden and therefore ignored when rendering.

bool CEGUI::Window::isZOrderingEnabled | ( | void |  | ) | const

Return whether z-order changes are enabled or disabled for this Window.

Note:
  This is distinguished from the is/setRiseOnClickEnabled setting in that if rise on click is disabled it only affects the users ability to affect the z order of the Window by clicking the mouse; is still possible to programatically alter the Window z-order by calling the moveToFront, moveToBack, moveInFront and moveBehind member functions. Whereas if z ordering is disabled those functions are also precluded from affecting the Window z position.

Returns:
  - true if z-order changes are enabled for this window. moveToFront, moveToBack, moveInFront and moveBehind work normally.
  - false: z-order changes are disabled for this window. moveToFront, moveToBack, moveInFront and moveBehind are ignored.

void CEGUI::Window::moveBehind | ( | const Window *const | window | ) |

Move this window immediately behind it's sibling window in the z order.

No action will be taken under the following conditions:

- window is 0.
- window is not a sibling of this window.
- window and this window have different AlwaysOnTop settings.
- z ordering is disabled for this window.

Parameters:

  window | The sibling window that this window will be moved behind.

void CEGUI::Window::moveInFront | ( | const Window *const | window | ) |

Move this window immediately above it's sibling window in the z order.

No action will be taken under the following conditions:

- window is 0.
- window is not a sibling of this window.
- window and this window have different AlwaysOnTop settings.
- z ordering is disabled for this window.

Parameters:

  window | The sibling window that this window will be moved in front of.

void CEGUI::Window::moveToBack | ( |  | ) |

Move the Window to the bottom of the Z order.

- If the window is non always-on-top the Window is sent to the very bottom of its sibling windows and the process repeated for all ancestors.
- If the window is always-on-top, the Window is sent to the bottom of all sibling always-on-top windows and the process repeated for all ancestors.

Returns:
  Nothing

void CEGUI::Window::moveToFront | ( |  | ) |

Move the Window to the top of the z order.

- If the Window is a non always-on-top window it is moved the the top of all other non always-on-top sibling windows, and the process repeated for all ancestors.
- If the Window is an always-on-top window it is moved to the of of all sibling Windows, and the process repeated for all ancestors.

Returns:
  Nothing

virtual bool CEGUI::Window::moveToFront_impl | ( | bool | wasClicked | ) | `[protected, virtual]`

Implements move to front behavior.

Returns:
  Should return true if some action was taken, or false if there was nothing to be done.

Reimplemented in CEGUI::GUISheet.

void CEGUI::Window::notifyScreenAreaChanged | ( | bool | recursive = `true` | ) |

Inform the window, and optionally all children, that screen area rectangles have changed.

Parameters:

  recursive | true to recursively call notifyScreenAreaChanged on attached child Window objects. false to just process this Window.

virtual void CEGUI::Window::onActivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window has become the active window.

Parameters:

  e | ActivationEventArgs class whose 'otherWindow' field is set to the window that previously was active, or NULL for none.

Reimplemented in CEGUI::Combobox, CEGUI::ComboDropList, CEGUI::FrameWindow, and CEGUI::Spinner.

virtual void CEGUI::Window::onAlphaChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's alpha blend value is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::DragContainer, and CEGUI::PopupMenu.

virtual void CEGUI::Window::onAlwaysOnTopChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's always-on-top setting is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onCaptureGained | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window gains capture of mouse inputs.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onCaptureLost | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window loses capture of mouse inputs.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::ButtonBase, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::Thumb, and CEGUI::Titlebar.

virtual void CEGUI::Window::onCharacter | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

Handler called when a character-key has been pressed while this window has input focus.

Parameters:

  e | KeyEventArgs object whose 'codepoint' field is set to the Unicode code point (encoded as utf32) for the character typed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated. All other fields should be considered as 'junk'.

Reimplemented in CEGUI::Editbox, and CEGUI::MultiLineEditbox.

virtual void CEGUI::Window::onChildAdded | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when a child window is added to this window.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that has been added.

Reimplemented in CEGUI::ScrolledContainer.

virtual void CEGUI::Window::onChildRemoved | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when a child window is removed from this window.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set the window that has been removed.

Reimplemented in CEGUI::MenuBase, and CEGUI::ScrolledContainer.

virtual void CEGUI::Window::onClippingChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's setting for being clipped by it's parent is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::DragContainer.

virtual void CEGUI::Window::onDeactivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window has lost input focus and has been deactivated.

Parameters:

  e | ActivationEventArgs object whose 'otherWindow' field is set to the window that has now become active, or NULL for none.

Reimplemented in CEGUI::FrameWindow.

virtual void CEGUI::Window::onDestructionStarted | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window's destruction sequence has begun.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::PopupMenu.

virtual void CEGUI::Window::onDisabled | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window is disabled.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onDragDropItemDropped | ( | DragDropEventArgs & | e | ) | `[protected, virtual]`

Handler called when a DragContainer is dragged over this window.

Parameters:

  e | DragDropEventArgs object initialised as follows: window field is normaly set to point to 'this' window. dragDropItem is a pointer to a DragContainer window that triggered the event.

virtual void CEGUI::Window::onDragDropItemEnters | ( | DragDropEventArgs & | e | ) | `[protected, virtual]`

Handler called when a DragContainer is dragged over this window.

Parameters:

  e | DragDropEventArgs object initialised as follows: window field is normaly set to point to 'this' window. dragDropItem is a pointer to a DragContainer window that triggered the event.

virtual void CEGUI::Window::onDragDropItemLeaves | ( | DragDropEventArgs & | e | ) | `[protected, virtual]`

Handler called when a DragContainer is dragged over this window.

Parameters:

  e | DragDropEventArgs object initialised as follows: window field is normaly set to point to 'this' window. dragDropItem is a pointer to a DragContainer window that triggered the event.

virtual void CEGUI::Window::onEnabled | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window is enabled.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onFontChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's font is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::Combobox, CEGUI::MultiColumnList, CEGUI::Spinner, CEGUI::TabControl, and CEGUI::Titlebar.

virtual void CEGUI::Window::onHidden | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window is hidden.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::MenuBase, and CEGUI::PopupMenu.

virtual void CEGUI::Window::onHorizontalAlignmentChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the horizontal alignment setting for the window is changed.

Parameters:

  e | WindowEventArgs object initialised as follows: window field is set to point to the Window object whos alignment has changed (typically 'this').

virtual void CEGUI::Window::onIDChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's client assigned ID is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onInheritsAlphaChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's setting for inheriting alpha-blending is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onKeyDown | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

Handler called when a key as been depressed while this window has input focus.

Parameters:

  e | KeyEventArgs object whose 'scancode' field is set to the Key::Scan value representing the key that was pressed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated.

Reimplemented in CEGUI::Editbox, CEGUI::ItemListbox, and CEGUI::MultiLineEditbox.

virtual void CEGUI::Window::onKeyUp | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

Handler called when a key as been released while this window has input focus.

Parameters:

  e | KeyEventArgs object whose 'scancode' field is set to the Key::Scan value representing the key that was released, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated. All other fields should be considered as 'junk'.

virtual void CEGUI::Window::onMouseButtonDown | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been depressed within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::ButtonBase, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::GUISheet, CEGUI::Listbox, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::PopupMenu, CEGUI::Scrollbar, CEGUI::Slider, CEGUI::TabButton, CEGUI::Thumb, CEGUI::Titlebar, and CEGUI::Tree.

virtual void CEGUI::Window::onMouseButtonUp | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been released within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::ButtonBase, CEGUI::Checkbox, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::GUISheet, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::PopupMenu, CEGUI::PushButton, CEGUI::RadioButton, CEGUI::TabButton, and CEGUI::Titlebar.

virtual void CEGUI::Window::onMouseClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been clicked (that is depressed and then released, within a specified time) within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::GUISheet, and CEGUI::ItemEntry.

virtual void CEGUI::Window::onMouseDoubleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been double-clicked within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::Editbox, CEGUI::GUISheet, CEGUI::ListHeaderSegment, CEGUI::MultiLineEditbox, and CEGUI::Titlebar.

virtual void CEGUI::Window::onMouseEnters | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor has entered this window's area and is actually over some part of this windows surface and not, for instance over a child window - even though technically in those cases the mouse is also within this Window's area, the handler will not be called.

Parameters:

  e | MouseEventArgs object. All fields are valid.

See also:
  Window::onMouseEntersArea

Reimplemented in CEGUI::Tooltip.

virtual void CEGUI::Window::onMouseEntersArea | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor has entered this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

virtual void CEGUI::Window::onMouseLeaves | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor is no longer over this window's surface area. This will be called when the mouse is not over a part of this Window's actual surface - even though technically the mouse is still within the Window's area, for example if the mouse moves over a child window.

Parameters:

  e | MouseEventArgs object. All fields are valid.

See also:
  Window::onMouseLeavesArea

Reimplemented in CEGUI::ButtonBase, CEGUI::ListHeaderSegment, and CEGUI::MenuItem.

virtual void CEGUI::Window::onMouseLeavesArea | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor has left this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

virtual void CEGUI::Window::onMouseMove | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor has been moved within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::ButtonBase, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::GUISheet, CEGUI::Listbox, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::TabButton, CEGUI::Thumb, CEGUI::Titlebar, and CEGUI::Tree.

virtual void CEGUI::Window::onMouseTripleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been triple-clicked within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::Editbox, CEGUI::GUISheet, and CEGUI::MultiLineEditbox.

virtual void CEGUI::Window::onMouseWheel | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse wheel (z-axis) position changes within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented in CEGUI::GUISheet, CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::ScrolledItemListBase, CEGUI::Slider, CEGUI::TabButton, and CEGUI::Tree.

virtual void CEGUI::Window::onMoved | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's position changes.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::DragContainer.

virtual void CEGUI::Window::onNonClientChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's non-client setting, affecting it's position and size relative to it's parent is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onParentDestroyChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's setting for being destroyed automatically be it's parent is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onParentSized | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window's parent window has been resized. If this window is the root / GUI Sheet window, this call will be made when the display size changes.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set the the window that caused the event; this is typically either this window's parent window, or NULL to indicate the screen size has changed.

Reimplemented in CEGUI::ItemListBase, and CEGUI::ScrolledContainer.

virtual void CEGUI::Window::onRenderingEnded | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when rendering for this window has ended.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onRenderingStarted | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when rendering for this window has started.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onRotated | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's rotation factor is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onShown | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window is shown (made visible).

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::PopupMenu.

virtual void CEGUI::Window::onSized | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's size changes.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ScrollablePane, and CEGUI::Tree.

virtual void CEGUI::Window::onTextChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's text is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented in CEGUI::Combobox, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::Spinner, and CEGUI::Tooltip.

virtual void CEGUI::Window::onTextParsingChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's setting for whether text parsing is enabled is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::onVerticalAlignmentChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the vertical alignment setting for the window is changed.

Parameters:

  e | WindowEventArgs object initialised as follows: window field is set to point to the Window object whos alignment has changed (typically 'this').

virtual void CEGUI::Window::onWindowRendererAttached | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when a new window renderer object is attached.

Parameters:

  e | WindowEventArgs object initialised as follows: window field is set to point to the Window object that just got a new window renderer attached. (typically 'this').

virtual void CEGUI::Window::onWindowRendererDetached | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the currently attached window renderer object is detached.

Parameters:

  e | WindowEventArgs object initialised as follows: window field is set to point to the Window object that just got lost its window renderer. (typically 'this').

virtual void CEGUI::Window::onZChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the z-order position of this window has changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

virtual void CEGUI::Window::performChildWindowLayout | ( |  | ) | `[virtual]`

method called to perform extended laying out of attached child windows.

The system may call this at various times (like when it is resized for example), and it may be invoked directly where required.

Returns:
  Nothing.

Reimplemented in CEGUI::ItemListBase, and CEGUI::TabControl.

virtual void CEGUI::Window::populateGeometryBuffer | ( |  | ) | `[inline, protected, virtual]`

Update the rendering cache.

Populates the Window's GeometryBuffer ready for rendering.

Reimplemented in CEGUI::Tree.

void CEGUI::Window::queueGeometry | ( | const RenderingContext & | ctx | ) | `[protected]`

Perform drawing operations concerned with positioning, clipping and queueing of window geometry to RenderingSurfaces.

Note:
  This function is a sub-function of drawSelf and is provided to make it easier to override drawSelf without needing to duplicate large sections of the code from the default implementation.

void CEGUI::Window::releaseInput | ( | void |  | ) |

Releases input capture from this Window. If this Window does not have inputs captured, nothing happens.

Returns:
  Nothing

void CEGUI::Window::removeChildWindow | ( | const String & | name | ) |

Remove the named Window from this windows child list.

Parameters:

  name | String object holding the name of the Window to be removed. If the Window specified is not attached to this Window, nothing happens.

Returns:
  Nothing.

void CEGUI::Window::removeChildWindow | ( | Window * | window | ) |

Remove the specified Window form this windows child list.

Parameters:

  window | Pointer to the Window object to be removed. If the window is not attached to this Window, then nothing happens.

Returns:
  Nothing.

void CEGUI::Window::removeChildWindow | ( | uint | ID | ) |

Remove the first child Window with the specified ID. If there is more than one attached Window objects with the specified ID, only the fist one encountered will be removed.

Parameters:

  ID | ID number assigned to the Window to be removed. If no Window with ID code ID is attached, nothing happens.

Returns:
  Nothing.

void CEGUI::Window::removeWindowFromDrawList | ( | const Window & | wnd | ) | `[protected]`

Removes the window from the drawing list. If the window is not attached to the drawing list then nothing happens.

Parameters:

  wnd | Window object to be removed from the drawing list.

Returns:
  Nothing.

void CEGUI::Window::rename | ( | const String & | new_name | ) |

Renames the window.

Parameters:

  new_name | String object holding the new name for the window.

Exceptions:

  AlreadyExistsException | thrown if a Window named new_name already exists in the system.

void CEGUI::Window::render | ( |  | ) |

Causes the Window object to render itself and all of it's attached children.

Returns:
  Nothing

bool CEGUI::Window::restoresOldCapture | ( | void |  | ) | const`[inline]`

Return whether this window is set to restore old input capture when it loses input capture.

This is only really useful for certain sub-components for widget writers.

Returns:
  - true if the window will restore the previous capture window when it loses input capture.
  - false if the window will set the capture window to NULL when it loses input capture (this is the default behaviour).

void CEGUI::Window::setAlpha | ( | float | alpha | ) |

Set the current alpha value for this window.

Note:
  The alpha value set for any given window may or may not be the final alpha value that is used when rendering. All window objects, by default, inherit alpha from thier parent window(s) - this will blend child windows, relatively, down the line of inheritance. This behaviour can be overridden via the setInheritsAlpha() method. To return the true alpha value that will be applied when rendering, use the getEffectiveAlpha() method.

Parameters:

  alpha | The new alpha value for the window. Value should be between 0.0f and 1.0f.

Returns:
  Nothing

void CEGUI::Window::setAlwaysOnTop | ( | bool | setting | ) |

Set whether this window is always on top, or not.

Parameters:

  setting | true to have the Window appear on top of all other non always on top windows false to allow the window to be covered by other normal windows.

Returns:
  Nothing

void CEGUI::Window::setArea | ( | const URect & | area | ) |

Set the window area.

Sets the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  area | URect describing the new area rectangle of the window area.

void CEGUI::Window::setArea | ( | const UDim & | xpos,
|  | const UDim & | ypos,
|  | const UDim & | width,
|  | const UDim & | height
| ) |  |

Set the window area.

Sets the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  xpos | UDim describing the new x co-ordinate (left edge) of the window area.
  ypos | UDim describing the new y co-ordinate (top-edge) of the window area.
  width | UDim describing the new width of the window area.
  height | UDim describing the new height of the window area.

void CEGUI::Window::setArea | ( | const UVector2 & | pos,
|  | const UVector2 & | size
| ) |  |

Set the window area.

Sets the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  pos | UVector2 describing the new position (top-left corner) of the window area.
  size | UVector2 describing the new size of the window area.

void CEGUI::Window::setArea_impl | ( | const UVector2 & | pos,
|  | const UVector2 & | size,
|  | bool | topLeftSizing = `false`,
|  | bool | fireEvents = `true`
| ) |  | `[protected]`

Implementation method to modify window area while correctly applying min / max size processing, and firing any appropriate events.

/note This is the implementation function for setting size and position. In order to simplify area management, from this point on, all modifications to window size and position (area rect) should come through here.

/param pos UVector2 object describing the new area position.

/param size UVector2 object describing the new area size.

/param topLeftSizing

- true to indicate the the operation is a sizing operation on the top and/or left edges of the area, and so window movement should be inhibited if size is at max or min.
- false to indicate the operation is not a strict sizing operation on the top and/or left edges and that the window position may change as required

/param fireEvents

- true if events should be fired as normal.
- false to inhibit firing of events (required, for example, if you need to call this from the onSize/onMove handlers).

void CEGUI::Window::setAutoRepeatDelay | ( | float | delay | ) |

Set the current auto-repeat delay setting for this window.

Parameters:

  delay | float value indicating the delay, in seconds, defore the first repeat mouse button down event should be triggered when autorepeat is enabled.

Returns:
  Nothing.

void CEGUI::Window::setAutoRepeatRate | ( | float | rate | ) |

Set the current auto-repeat rate setting for this window.

Parameters:

  rate | float value indicating the rate, in seconds, at which repeat mouse button down events should be generated after the initial delay has expired.

Returns:
  Nothing.

void CEGUI::Window::setClippedByParent | ( | bool | setting | ) |

Set whether this Window will be clipped by its parent window(s).

Parameters:

  setting | true to have the Window clipped so that rendering is constrained to within the area of its parent(s). false to have rendering constrained to the screen only.

Returns:
  Nothing

void CEGUI::Window::setDestroyedByParent | ( | bool | setting | ) |

Set whether or not this Window will automatically be destroyed when its parent Window is destroyed.

Parameters:

  setting | true to have the Window auto-destroyed when its parent is destroyed (default behaviour) false to have the Window remain after its parent is destroyed.

Returns:
  Nothing

void CEGUI::Window::setDistributesCapturedInputs | ( | bool | setting | ) |

Set whether the window wants inputs passed to its attached child windows when the window has inputs captured.

Parameters:

  setting | true if System should pass captured input events to child windows. false if System should pass captured input events to this window only.

void CEGUI::Window::setDragDropTarget | ( | bool | setting | ) |

Specifies whether this Window object will receive events generated by the drag and drop support in the system.

Parameters:

  setting | true to enable the Window as a drag and drop target. false to disable the Window as a drag and drop target.

void CEGUI::Window::setEnabled | ( | bool | setting | ) |

Set whether this window is enabled or disabled. A disabled window normally can not be interacted with, and may have different rendering.

Parameters:

  setting | true to enable the Window false to disable the Window.

Returns:
  Nothing

void CEGUI::Window::setFalagardType | ( | const String & | type,
|  | const String & | rendererType = `""`
| ) |  |

Changes the widget's falagard type, thus changing its look'n'feel and optionally its renderer in the process.

Parameters:

  type | New look'n'feel of the widget
  type | New renderer of the widget

void CEGUI::Window::setFont | ( | const String & | name | ) |

Set the font used by this Window.

Parameters:

  name | String object holding the name of the Font object to be used by this Window. If name == "", the default font will be used.

Returns:
  Nothing

Exceptions:

  UnknownObjectException | thrown if the specified Font is unknown within the system.

void CEGUI::Window::setFont | ( | Font * | font | ) |

Set the font used by this Window.

Parameters:

  font | Pointer to the Font object to be used by this Window. If font is NULL, the default font will be used.

Returns:
  Nothing

void CEGUI::Window::setHeight | ( | const UDim & | height | ) |

Set the window's height.

Sets the height of the area occupied by this window.

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  height | UDim describing the new height of the window area.

void CEGUI::Window::setHorizontalAlignment | ( | const HorizontalAlignment | alignment | ) |

Set the horizontal alignment.

Modifies the horizontal alignment for the window. This setting affects how the windows position is interpreted relative to its parent.

Parameters:

  alignment | One of the HorizontalAlignment enumerated values.

Returns:
  Nothing.

void CEGUI::Window::setID | ( | uint | ID | ) |

Set the current ID for the Window.

Parameters:

  ID | Client assigned ID code for this Window. The GUI system assigns no meaning to any IDs, they are a device purely for client code usage.

Returns:
  Nothing

void CEGUI::Window::setInheritsAlpha | ( | bool | setting | ) |

Sets whether this Window will inherit alpha from its parent windows.

Parameters:

  setting | true if the Window should use inherited alpha. false if the Window should have an independant alpha value.

Returns:
  Nothing

void CEGUI::Window::setInheritsTooltipText | ( | bool | setting | ) |

Set whether this window inherits Tooltip text from its parent when its own tooltip text is not set.

Parameters:

  setting | true if the window should inherit tooltip text from its parent when its own text is not set. false if the window should not inherit tooltip text from its parent (and so show no tooltip when no text is set).

Returns:
  Nothing.

virtual void CEGUI::Window::setLookNFeel | ( | const String & | look | ) | `[virtual]`

Set the LookNFeel that shoule be used for this window.

Parameters:

  look | String object holding the name of the look to be assigned to the window.

Returns:
  Nothing.

Exceptions:

  UnknownObjectException | thrown if the look'n'feel specified by look does not exist.

Note:
  Once a look'n'feel has been assigned it is locked - as in cannot be changed.

Reimplemented in CEGUI::Tree.

void CEGUI::Window::setMaxSize | ( | const UVector2 & | size | ) |

Set the window's maximum size.

Sets the maximum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  size | UVector2 describing the new maximum size of the window area.

void CEGUI::Window::setMinSize | ( | const UVector2 & | size | ) |

Set the window's minimum size.

Sets the minimum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  size | UVector2 describing the new minimum size of the window area.

void CEGUI::Window::setModalState | ( | bool | state | ) |

Set the modal state for this Window.

Parameters:

  state | Boolean value defining if this Window should be the modal target. true if this Window should be activated and set as the modal target. false if the modal target should be cleared if this Window is currently the modal target.

Returns:
  Nothing.

void CEGUI::Window::setMouseAutoRepeatEnabled | ( | bool | setting | ) |

Set whether mouse button down event autorepeat is enabled for this window.

Parameters:

  setting | true to enable autorepeat of mouse button down events. false to disable autorepeat of mouse button down events.

Returns:
  Nothing.

void CEGUI::Window::setMouseCursor | ( | MouseCursorImage | image | ) |

Set the mouse cursor image to be used when the mouse enters this window.

Parameters:

  image | One of the MouseCursorImage enumerated values.

Returns:
  Nothing.

void CEGUI::Window::setMouseCursor | ( | const String & | imageset,
|  | const String & | image_name
| ) |  |

Set the mouse cursor image to be used when the mouse enters this window.

Parameters:

  imageset | String object that contains the name of the Imageset that contains the image to be used.
  image_name | String object that contains the name of the Image on imageset that is to be used.

Returns:
  Nothing.

Exceptions:

  UnknownObjectException | thrown if imageset is not known, or if imageset contains no Image named image_name.

void CEGUI::Window::setMouseCursor | ( | const Image * | image | ) |

Set the mouse cursor image to be used when the mouse enters this window.

Parameters:

  image | Pointer to the Image object to use as the mouse cursor image when the mouse enters the area for this Window.

Returns:
  Nothing.

void CEGUI::Window::setMouseInputPropagationEnabled | ( | const bool | enabled | ) |

Set whether mouse input that is not directly handled by this Window (including it's event subscribers) should be propagated back to the Window's parent.

Parameters:

  enabled | true if unhandled mouse input should be propagated to the parent. false if unhandled mouse input should not be propagated.

void CEGUI::Window::setMousePassThroughEnabled | ( | bool | setting | ) | `[inline]`

Sets whether this window should ignore mouse events and pass them through to any windows behind it. In effect making the window transparent to the mouse.

Parameters:

  setting | true if mouse pass through is enabled. false if mouse pass through is not enabled.

void CEGUI::Window::setNonClientWindow | ( | const bool | setting | ) |

Set whether the Window is a non-client window.

A non-client window is clipped, positioned and sized according to the parent window's full area as opposed to just the inner rect area used for normal client windows.

Parameters:

  setting | true if the window should be clipped, positioned and sized according to the full area rectangle of it's parent. false if the window should be clipped, positioned and sized according to the inner rect area of it's parent.

void CEGUI::Window::setParent | ( | Window * | parent | ) | `[protected]`

Set the parent window for this window object.

Parameters:

  parent | Pointer to a Window object that is to be assigned as the parent to this Window.

Returns:
  Nothing

void CEGUI::Window::setPosition | ( | const UVector2 & | pos | ) |

Set the window's position.

Sets the position of the area occupied by this window. The position is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  pos | UVector2 describing the new position (top-left corner) of the window area.

void CEGUI::Window::setRenderingSurface | ( | RenderingSurface * | surface | ) |

Set the RenderingSurface to be associated with this Window, or 0 if none is required.

  If this function is called, and the option for automatic use of an imagery caching RenderingSurface is enabled, any automatically created RenderingSurface will be released, and the affore mentioned option will be disabled.

  If after having set a custom RenderingSurface you then subsequently enable the automatic use of an imagery caching RenderingSurface by calling setUsingAutoRenderingSurface, the previously set RenderingSurface will be disassociated from the Window. Note that the previous RenderingSurface is not destroyed or cleaned up at all - this is the job of whoever created that object initially.

Parameters:

  target | Pointer to the RenderingSurface object to be associated with the window.

void CEGUI::Window::setRestoreCapture | ( | bool | setting | ) |

Set whether this window will remember and restore the previous window that had inputs captured.

Parameters:

  setting | true: The window will remember and restore the previous capture window. The CaptureLost event is not fired on the previous window when this window steals input capture. When this window releases capture, the old capture window is silently restored.

- false: Input capture works as normal, each window losing capture is signalled via CaptureLost, and upon the final release of capture, no previous setting is restored (this is the default behaviour).

Returns:
  Nothing

void CEGUI::Window::setRiseOnClickEnabled | ( | bool | setting | ) | `[inline]`

Set whether this window will rise to the top of the z-order when clicked with the left mouse button.

Note:
  This is distinguished from the is/setZOrderingEnabled setting in that if rise on click is disabled it only affects the users ability to affect the z order of the Window by clicking the mouse; is still possible to programatically alter the Window z-order by calling the moveToFront, moveToBack, moveInFront and moveBehind member functions. Whereas if z ordering is disabled those functions are also precluded from affecting the Window z position.

Parameters:

  setting | true if the window should come to the top of other windows when the left mouse button is pushed within its area. false if the window should not change z-order position when the left mouse button is pushed within its area.

Returns:
  Nothing.

void CEGUI::Window::setSize | ( | const UVector2 & | size | ) |

Set the window's size.

Sets the size of the area occupied by this window.

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  size | UVector2 describing the new size of the window area.

void CEGUI::Window::setText | ( | const String & | text | ) |

Set the current text string for the Window.

Parameters:

  text | String object containing the text that is to be set as the Window text.

Returns:
  Nothing

void CEGUI::Window::setTooltip | ( | Tooltip * | tooltip | ) |

Set the custom Tooltip object for this Window. This value may be 0 to indicate that the Window should use the system default Tooltip object.

Parameters:

  tooltip | Pointer to a valid Tooltip based object which should be used as the tooltip for this Window, or 0 to indicate that the Window should use the system default Tooltip object. Note that when passing a pointer to a Tooltip object, ownership of the Tooltip does not pass to this Window object.

Returns:
  Nothing.

void CEGUI::Window::setTooltipText | ( | const String & | tip | ) |

Set the tooltip text for this window.

Parameters:

  tip | String object holding the text to be displayed in the tooltip for this Window.

Returns:
  Nothing.

void CEGUI::Window::setTooltipType | ( | const String & | tooltipType | ) |

Set the custom Tooltip to be used by this Window by specifying a Window type.

The Window will internally attempt to create an instance of the specified window type (which must be derived from the base Tooltip class). If the Tooltip creation fails, the error is logged and the Window will revert to using either the existing custom Tooltip or the system default Tooltip.

Parameters:

  tooltipType | String object holding the name of the Tooltip based Window type which should be used as the Tooltip for this Window.

Returns:
  Nothing.

void CEGUI::Window::setUpdateMode | ( | const WindowUpdateMode | mode | ) |

Set the window update mode. This mode controls the behaviour of the Window::update member function such that updates are processed for this window (and therefore it's child content) according to the set mode.

Note:
  Disabling updates can have negative effects on the behaviour of CEGUI windows and widgets; updates should be disabled selectively and cautiously - if you are unsure of what you are doing, leave the mode set to WUM_ALWAYS.

Parameters:

  mode | One of the WindowUpdateMode enumerated values indicating the mode to set for this Window.

void CEGUI::Window::setUserData | ( | void * | user_data | ) | `[inline]`

Set the user data set for this Window.

Each Window can have some client assigned data attached to it, this data is not used by the GUI system in any way. Interpretation of the data is entirely application specific.

Parameters:

  user_data | pointer to the user data that is to be set for this window.

Returns:
  Nothing.

void CEGUI::Window::setUserString | ( | const String & | name,
|  | const String & | value
| ) |  |

Sets the value a named user string, creating it as required.

Parameters:

  name | String object holding the name of the string to be returned.
  value | String object holding the value to be assigned to the user string.

Returns:
  Nothing.

void CEGUI::Window::setUsingAutoRenderingSurface | ( | bool | setting | ) |

Sets whether automatic use of an imagery caching RenderingSurface (i.e. a RenderingWindow) is enabled for this window. The reason we emphasise 'atutomatic' is because the client may manually set a RenderingSurface that does exactlythe same job.

  Note that this setting really only controls whether the Window automatically creates and manages the RenderingSurface, as opposed to the use of the RenderingSurface. If a RenderingSurfaceis set for the Window it will be used regardless of this setting.

  Enabling this option will cause the Window to attempt to create a suitable RenderingSurface (which will actually be a RenderingWindow). If there is an existing RenderingSurface assocated with this Window, it will be removed as the Window's RenderingSurface but not destroyed; whoever created the RenderingSurface in the first place should take care of its destruction.

  Disabling this option will cause any automatically created RenderingSurface to be released.

  It is possible that the renderer in use may not support facilities for RenderingSurfaces that are suitable for full imagery caching. If this is the case, then calling getRenderingSurface after enabling this option will return 0. In these cases this option will still show as being 'enabled', this is because Window settings should not be influenced by capabilities the renderer in use; for example, this enables correct XML layouts to be written from a Window on a system that does not support such RenderingSurfaces, so that the layout will function as preferred on systems that do.

  If this option is enabled, and the client subsequently assigns a different RenderingSurface to the Window, the existing automatically created RenderingSurface will be released and this setting will be disabled.

Parameters:

  setting | true to enable automatic use of an imagery caching RenderingSurface. false to disable automatic use of an imagery caching RenderingSurface.

void CEGUI::Window::setVerticalAlignment | ( | const VerticalAlignment | alignment | ) |

Set the vertical alignment.

Modifies the vertical alignment for the window. This setting affects how the windows position is interpreted relative to its parent.

Parameters:

  alignment | One of the VerticalAlignment enumerated values.

Returns:
  Nothing.

void CEGUI::Window::setVisible | ( | bool | setting | ) |

Set whether the Window is visible or hidden.

Parameters:

  setting | true to make the Window visible. false to make the Window hidden.

Note:
  Hiding the active window will cause that window to become deactivated. Showing a window does not, however, automatically cause that window to become the active window (call Window::activate after making the window visible to activate it).

Returns:
  Nothing

void CEGUI::Window::setWantsMultiClickEvents | ( | bool | setting | ) |

Set whether this window will receive multi-click events or multiple 'down' events instead.

Parameters:

  setting | true if the Window will receive double-click and triple-click events. false if the Window will receive multiple mouse button down events instead of double/triple click events.

Returns:
  Nothing.

void CEGUI::Window::setWidth | ( | const UDim & | width | ) |

Set the window's width.

Sets the width of the area occupied by this window.

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  width | UDim describing the new width of the window area.

void CEGUI::Window::setWindowRenderer | ( | const String & | name | ) |

Assign the WindowRenderer to specify the Look'N'Feel specification to be used.

Parameters:

  name | The factory name of the WindowRenderer to use.

Note:
  Once a window renderer has been assigned it is locked - as in cannot be changed.

void CEGUI::Window::setXPosition | ( | const UDim & | x | ) |

Set the window's X position.

Sets the x position (left edge) of the area occupied by this window. The position is offset from the left edge of this windows parent window or from the left edge of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  x | UDim describing the new x position of the window area.

void CEGUI::Window::setYPosition | ( | const UDim & | y | ) |

Set the window's Y position.

Sets the y position (top edge) of the area occupied by this window. The position is offset from the top edge of this windows parent window or from the top edge of the display if this window has no parent (i.e. it is the root window).

Note:
  This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used.

Parameters:

  y | UDim describing the new y position of the window area.

void CEGUI::Window::setZOrderingEnabled | ( | bool | setting | ) |

Set whether z-order changes are enabled or disabled for this Window.

Note:
  This is distinguished from the is/setRiseOnClickEnabled setting in that if rise on click is disabled it only affects the users ability to affect the z order of the Window by clicking the mouse; is still possible to programatically alter the Window z-order by calling the moveToFront, moveToBack, moveInFront and moveBehind member functions. Whereas if z ordering is disabled those functions are also precluded from affecting the Window z position.

Parameters:

  setting | true if z-order changes are enabled for this window. moveToFront, moveToBack, moveInFront and moveBehind work normally. false: z-order changes are disabled for this window. moveToFront, moveToBack, moveInFront and moveBehind are ignored.

Returns:
  Nothing.

void CEGUI::Window::show | ( | void |  | ) | `[inline]`

show the Window.

Note:
  Showing a window does not automatically activate the window. If you want the window to also become active you will need to call the Window::activate member also.

Returns:
  Nothing

bool CEGUI::Window::testClassName | ( | const String & | class_name | ) | const`[inline]`

Return whether this window was inherited from the given class name at some point in the inheritance hierarchy.

Parameters:

  class_name | The class name that is to be checked.

Returns:
  true if this window was inherited from class_name. false if not.

virtual bool CEGUI::Window::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

Return whether this window was inherited from the given class name at some point in the inheritance hierarchy.

Parameters:

  class_name | The class name that is to be checked.

Returns:
  true if this window was inherited from class_name. false if not.

Reimplemented in CEGUI::ButtonBase, CEGUI::Checkbox, CEGUI::ClippedContainer, CEGUI::Combobox, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::GridLayoutContainer, CEGUI::GroupBox, CEGUI::GUISheet, CEGUI::HorizontalLayoutContainer, CEGUI::ItemEntry, CEGUI::ItemListBase, CEGUI::ItemListbox, CEGUI::LayoutContainer, CEGUI::Listbox, CEGUI::ListHeader, CEGUI::ListHeaderSegment, CEGUI::Menubar, CEGUI::MenuBase, CEGUI::MenuItem, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::PopupMenu, CEGUI::ProgressBar, CEGUI::PushButton, CEGUI::RadioButton, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::ScrolledContainer, CEGUI::ScrolledItemListBase, CEGUI::SequentialLayoutContainer, CEGUI::Slider, CEGUI::Spinner, CEGUI::TabButton, CEGUI::TabControl, CEGUI::Thumb, CEGUI::Titlebar, CEGUI::Tooltip, CEGUI::Tree, and CEGUI::VerticalLayoutContainer.

Referenced by CEGUI::Tree::testClassName_impl(), CEGUI::Tooltip::testClassName_impl(), CEGUI::Titlebar::testClassName_impl(), CEGUI::TabControl::testClassName_impl(), CEGUI::Spinner::testClassName_impl(), CEGUI::Slider::testClassName_impl(), CEGUI::ScrolledContainer::testClassName_impl(), CEGUI::Scrollbar::testClassName_impl(), CEGUI::ScrollablePane::testClassName_impl(), CEGUI::ProgressBar::testClassName_impl(), CEGUI::MultiLineEditbox::testClassName_impl(), CEGUI::MultiColumnList::testClassName_impl(), CEGUI::ListHeaderSegment::testClassName_impl(), CEGUI::ListHeader::testClassName_impl(), CEGUI::Listbox::testClassName_impl(), CEGUI::LayoutContainer::testClassName_impl(), CEGUI::ItemListBase::testClassName_impl(), CEGUI::ItemEntry::testClassName_impl(), CEGUI::GUISheet::testClassName_impl(), CEGUI::GroupBox::testClassName_impl(), CEGUI::FrameWindow::testClassName_impl(), CEGUI::Editbox::testClassName_impl(), CEGUI::DragContainer::testClassName_impl(), CEGUI::Combobox::testClassName_impl(), CEGUI::ClippedContainer::testClassName_impl(), and CEGUI::ButtonBase::testClassName_impl().

virtual void CEGUI::Window::update | ( | float | elapsed | ) | `[virtual]`

Cause window to update itself and any attached children. Client code does not need to call this method; to ensure full, and proper updates, call the injectTimePulse methodname method provided by the System class.

Note:
  The update order is such that 'this' window is updated prior to any child windows, this is so that child windows that access the parent in their update code get the correct updated state.

Parameters:

  elapsed | float value indicating the number of seconds passed since the last update.

Returns:
  Nothing.

Reimplemented in CEGUI::LayoutContainer.

virtual void CEGUI::Window::updateSelf | ( | float | elapsed | ) | `[protected, virtual]`

Perform actual update processing for this Window.

Parameters:

  elapsed | float value indicating the number of seconds elapsed since the last update call.

Returns:
  Nothing.

Reimplemented in CEGUI::MenuItem, CEGUI::PopupMenu, and CEGUI::Tooltip.

virtual bool CEGUI::Window::validateWindowRenderer | ( | const String & | name | ) | const`[protected, virtual]`

Function used in checking if a WindowRenderer is valid for this window.

Returns:
  Returns true if the given WindowRenderer class name is valid for this window. False if not.

Reimplemented in CEGUI::Editbox, CEGUI::ItemEntry, CEGUI::ItemListBase, CEGUI::Listbox, CEGUI::ListHeader, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::Slider, CEGUI::TabControl, and CEGUI::Tooltip.

bool CEGUI::Window::wantsMultiClickEvents | ( | void |  | ) | const

Return whether this window will receive multi-click events or multiple 'down' events instead.

Returns:
  - true if the Window will receive double-click and triple-click events.
  - false if the Window will receive multiple mouse button down events instead of double/triple click events.

virtual void CEGUI::Window::writeXMLToStream | ( | XMLSerializer & | xml_stream | ) | const`[virtual]`

Writes an xml representation of this window object to out_stream.

Parameters:

  xml_stream | Stream where xml data should be output.

Returns:
  Nothing.

## Member Data Documentation

const String CEGUI::Window::EventActivated`[static]`

Event fired when the Window has been activated and has input focus. Handlers are passed a const ActivationEventArgs reference with WindowEventArgs::window set to the Window that is gaining activation and ActivationEventArgs::otherWindow set to the Window that is losing activation (may be 0).

const String CEGUI::Window::EventAlphaChanged`[static]`

Event fired when the Alpha blend value for the Window has changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose alpha value was changed.

const String CEGUI::Window::EventAlwaysOnTopChanged`[static]`

Event fired when the always on top setting for the Window is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose always on top setting was changed.

const String CEGUI::Window::EventCharacterKey`[static]`

Event fired when the Window receives a character key input event. Handlers are passed a const KeyEventArgs reference with WindowEventArgs::window set to the Window receiving the character input, KeyEventArgs::codepoint set to the Unicode UTF32 / UCS-4 value for the input, and KeyEventArgs::sysKeys set to the combination of SystemKey values active when the character input was received.

const String CEGUI::Window::EventChildAdded`[static]`

Event fired when a child Window has been added. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the child window that was added.

const String CEGUI::Window::EventChildRemoved`[static]`

Event fired when a child window has been removed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the child window that was removed.

const String CEGUI::Window::EventClippedByParentChanged`[static]`

Event fired when the Window clipping mode is modified. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose clipping mode was changed.

const String CEGUI::Window::EventDeactivated`[static]`

Event fired when the Window has been deactivated, losing input focus. Handlers are passed a const ActivationEventArgs reference with WindowEventArgs::window set to the Window that is losing activation and ActivationEventArgs::otherWindow set to the Window that is gaining activation (may be 0).

const String CEGUI::Window::EventDestroyedByParentChanged`[static]`

Event fired when the Window destruction mode is modified. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose destruction mode was changed.

const String CEGUI::Window::EventDestructionStarted`[static]`

Event fired when destruction of the Window is about to begin. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window that is about to be destroyed.

const String CEGUI::Window::EventDisabled`[static]`

Event fired when the Window is disabled and interaction is no longer possible. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window that was disabled.

const String CEGUI::Window::EventDragDropItemDropped`[static]`

Event fired when a DragContainer is dropped within the window's area. Handlers are passed a const DragDropEventArgs reference with WindowEventArgs::window set to the window over which a DragContainer was dropped (the receiving window) and DragDropEventArgs::dragDropItem set to the DragContainer that was dropped within the receiving window's area.

const String CEGUI::Window::EventDragDropItemEnters`[static]`

Event fired when a DragContainer is dragged in to the window's area. Handlers are passed a const DragDropEventArgs reference with WindowEventArgs::window set to the window over which a DragContainer has been dragged (the receiving window) and DragDropEventArgs::dragDropItem set to the DragContainer that was dragged in to the receiving window's area.

const String CEGUI::Window::EventDragDropItemLeaves`[static]`

Event fired when a DragContainer is dragged out of the window's area. Handlers are passed a const DragDropEventArgs reference with WindowEventArgs::window set to the window over which a DragContainer has been dragged out of (the receiving window) and DragDropEventArgs::dragDropItem set to the DragContainer that was dragged out of the receiving window's area.

const String CEGUI::Window::EventEnabled`[static]`

Event fired when the Window is enabled so interaction is possible. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window that was enabled.

const String CEGUI::Window::EventFontChanged`[static]`

Event fired when the Font object for the Window has been changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose font was changed.

const String CEGUI::Window::EventHidden`[static]`

Event fired when the Window is made hidden. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window that was hidden.

const String CEGUI::Window::EventHorizontalAlignmentChanged`[static]`

Event fired when the horizontal alignment for the window is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the window whose horizontal alignment setting was changed.

const String CEGUI::Window::EventIDChanged`[static]`

Event fired when the client assigned ID for the Window has changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose ID was changed.

const String CEGUI::Window::EventInheritsAlphaChanged`[static]`

Event fired when the Window mode controlling inherited alpha is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose alpha inheritence mode was changed.

const String CEGUI::Window::EventInputCaptureGained`[static]`

Event fired when the Window gains capture of mouse inputs. Handlers are passed a cont WindowEventArgs reference with WindowEventArgs::window set to the Window that has captured mouse inputs.

const String CEGUI::Window::EventInputCaptureLost`[static]`

Event fired when the Window loses capture of mouse inputs. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to either:

- the Window that has lost capture of mouse inputs if that event was caused by the window itself releasing the capture.
- the Window that is capture of mouse inputs if that is the cause of the previous window with capture losing that capture.

const String CEGUI::Window::EventKeyDown`[static]`

Event fired when a key on the keyboard was pressed down while the window had input focus. Handlers are passed a const KeyEventArgs reference with WindowEventArgs::window set to the Window receiving the key press, KeyEventArgs::scancode set to the Key::Scan value of the key that was pressed, and KeyEventArgs::sysKeys set to the combination of SystemKey values active when the key was pressed.

const String CEGUI::Window::EventKeyUp`[static]`

Event fired when a key on the keyboard was released while the window had input focus. Handlers are passed a const KeyEventArgs reference with WindowEventArgs::window set to the Window receiving the key release, KeyEventArgs::scancode set to the Key::Scan value of the key that was released, and KeyEventArgs::sysKeys set to the combination of SystemKey values active when the key was released.

const String CEGUI::Window::EventMarginChanged`[static]`

Event fired when the Window's margin has changed (any of the four margins) Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose margin was changed.

const String CEGUI::Window::EventMouseButtonDown`[static]`

Event fired when a mouse button is pressed down within the Window. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseButtonUp`[static]`

Event fired when a mouse button is released within the Window. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseClick`[static]`

Event fired when a mouse button is clicked - that is, pressed down and released within a specific time interval - while the mouse cursor is within the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseDoubleClick`[static]`

Event fired when a mouse button is double-clicked while the mouse cursor is within the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseEnters`[static]`

Event fired when the mouse cursor enters the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

Note:
  This event is fired if - and only if - the mouse cursor is actually over some part of this Window's surface area, and will not fire for example if the location of the mouse is over some child window (even though the mouse is technically also within the area of this Window). For an alternative version of this event see the Window::EventMouseEntersArea event.

const String CEGUI::Window::EventMouseEntersArea`[static]`

Event fired when the mouse cursor has entered the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseLeaves`[static]`

Event fired when the mouse cursor is no longer over the Window's surface area. Handlers are passed a const MouseEventArgs reference with all fields valid.

Note:
  This event will fire whenever the mouse is no longer actually over some part of this Window's surface area, for example if the mouse is moved over some child window (even though technically the mouse has not actually 'left' this Window's area). For an alternative version of this event see the Window::EventMouseLeavesArea event.

const String CEGUI::Window::EventMouseLeavesArea`[static]`

Event fired when themouse cursor has left the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseMove`[static]`

Event fired when the mouse cursor moves within the area of the Window. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseTripleClick`[static]`

Event fired when a mouse button is triple-clicked while the mouse cursor is within the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMouseWheel`[static]`

Event fired when the mouse wheel is scrolled when the mouse cursor is within the Window's area. Handlers are passed a const MouseEventArgs reference with all fields valid.

const String CEGUI::Window::EventMoved`[static]`

Event fired when the Window position has changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose position was changed.

const String CEGUI::Window::EventNonClientChanged`[static]`

Event fired when the non-client setting for the Window is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose non-client setting was changed.

const String CEGUI::Window::EventParentSized`[static]`

Event fired when the parent of this Window has been re-sized. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window pointing to the parent window that was resized, not the window whose parent was resized.

const String CEGUI::Window::EventRenderingEnded`[static]`

Event fired when rendering of the Window has ended. In this context 'rendering' is the population of the GeometryBuffer with geometry for the window, not the actual rendering of that GeometryBuffer content to the display. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose rendering has ended.

const String CEGUI::Window::EventRenderingStarted`[static]`

Event fired when rendering of the Window has started. In this context 'rendering' is the population of the GeometryBuffer with geometry for the window, not the actual rendering of that GeometryBuffer content to the display. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose rendering has started.

const String CEGUI::Window::EventRotated`[static]`

Event fired whrn the rotation factor(s) for the window are changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose rotation was changed.

const String CEGUI::Window::EventShown`[static]`

Event fired when the Window is shown (made visible). Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window that was shown.

const String CEGUI::Window::EventSized`[static]`

Event fired when the Window size has changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose size was changed.

const String CEGUI::Window::EventTextChanged`[static]`

Event fired when the text string for the Window has changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose text was changed.

const String CEGUI::Window::EventTextParsingChanged`[static]`

Event fired when the Window's setting controlling parsing of it's text string is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose text parsing setting was changed.

const String CEGUI::Window::EventVerticalAlignmentChanged`[static]`

Event fired when the vertical alignment for the window is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the window whose vertical alignment setting was changed.

const String CEGUI::Window::EventWindowRendererAttached`[static]`

Event fired when a WindowRenderer object is attached to the window. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the window that had the WindowRenderer attached to it.

const String CEGUI::Window::EventWindowRendererDetached`[static]`

Event fired when a WindowRenderer object is detached from the window. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the window that had the WindowRenderer detached from it.

const String CEGUI::Window::EventWindowUpdated`[static]`

Event fired as part of the time based update of the window. Handlers are passed a const UpdateEventArgs reference.

const String CEGUI::Window::EventZOrderChanged`[static]`

Event fired when the z-order of the window has changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the Window whose z order position has changed.